<%@ page import="commgrids.nuggets.wiley.schema.Author" %>
<%@ page import="commgrids.nuggets.wiley.schema.Affiliation" %>
<jsp:useBean id="documents" scope="page" class="commgrids.nuggets.wiley.bean.newdocParam" />
<jsp:setProperty name="documents" property="*" />
<jsp:useBean id="docParameter" scope="page" class="commgrids.nuggets.wiley.util.Parameter" />
<jsp:useBean id="authorHash" scope="page" class="java.util.Hashtable" />
<jsp:useBean id="keywordHash" scope="page" class="java.util.Hashtable" />
<jsp:useBean id="userBean" scope="session" class="commgrids.nuggets.wiley.User"/>

<html>
<head>
<title>Wiley Document Post</title>
<script language="JavaScript" type="text/JavaScript">
   function checkform_onsubmit(){
      var documentForm = document.postDocuments;

      publisherName      = documentForm.publisherName.value;
      DOIURI             = documentForm.DOIURI.value;
      vid                = documentForm.VID.value;
      iid                = documentForm.IID.value;
      author_fname       = documentForm.author_fname_0.value;
      author_lname       = documentForm.author_lname_0.value;
      author_email       = documentForm.author_email_0.value;
      articleTitle       = documentForm.articleTitle.value;
      abstractParam      = documentForm.abstractParam.value;


      regEmail_Format = /^[^@ ]+@[^@ \.][^@ ]*\.[^@ \.]+$/;

      isEmailOK = regEmail_Format.exec(author_email);

      strMsg = 'Please supply the following before  continue!:\n\n';
      boolProblem = false;
      //////////
      if(publisherName == "") { boolProblem=true; strMsg += "    Publisher Name\n"; }

      if(vid == "") { boolProblem=true; strMsg += "     VID\n"; }

      if(iid =="" ) { boolProblem=true; strMsg += "     IID\n"; }

      if(DOIURI =="" ) { boolProblem=true; strMsg += "     Digital Object Identifier(URI)\n"; }

      if(author_fname == "") { boolProblem=true; strMsg += "     Author First Name\n"; }

      if(author_lname == "") { boolProblem=true; strMsg += "     Author Last Name\n"; }

      if(author_email == "") { boolProblem=true; strMsg += "     Author Email\n\n"; }

      if(articleTitle == "") { boolProblem=true; strMsg += "     Article Title \n\n"; }

      if(abstractParam == "") { boolProblem=true; strMsg += "     abstract\n"; }

      if(boolProblem) {

      alert(strMsg);

 return false;

 }

 else if (!isEmailOK) {
    alert("The email you have entered is not in the correct format.");
    return false;
 }

 else {
  return true;
      }

 }
</script>

<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
</head>

<body bgcolor="#CCCCCC">

<%
  //parameters defined here to get document action objects
  String sendDocValue =request.getParameter("sendDoc");
  String numAuthor=request.getParameter("numOfAuthor");
  String numKeyword=request.getParameter("numOfKeyword");

  String removeAuthor =request.getParameter("removeAuthor");
  String addAuthor=request.getParameter("addAuthor");

  String addKeyword=request.getParameter("addKeyword");
  String removeKeyword=request.getParameter("removeKeyword");

  int numAut=1;
  int numKey=1;
  boolean check=false;
  boolean checkKey=false;



  ////////////////////////////////////////////////////////

  //forward paramss to the getDocument page
  if(sendDocValue!=null && sendDocValue.length()>0)
    {  %>
     <jsp:forward page="getDocument.jsp" />
     <%
     }


    /*-----------start adding and removing author-----------------*/
        if ((numAuthor!=null)&&(numAuthor!="")){
             numAut=Integer.parseInt(numAuthor);

        }

    //System.out.println("add :"+add);

    if ((removeAuthor!=null)&&(removeAuthor!=""))
            if (removeAuthor.equals("removeAuthor")) {
               check=true;
               if (numAut!=0)
                  if(numAut==1)
                     out.println("you are not allowed to more one author");
               else
               numAut--;
            //System.out.print("number of Author: "+numAut);
              }


    if ((addAuthor!=null)&&(addAuthor!=""))
            if (addAuthor.equals("addAuthor")) {
               check=true;
               numAut=numAut+3;

             }
     //get the author list
      for (int i=0; i< numAut; i++){

                  String number = String.valueOf(i);
       //Integer.toString(i);

          Author author = new Author();
          Affiliation aff =new Affiliation();


          if(request.getParameter("author_fname_"+number)==null)
             author.setFirstName("");
             else
             author.setFirstName(request.getParameter("author_fname_"+number));

          if(request.getParameter("author_lname_"+number)==null)
             author.setLastName("");
             else
             author.setLastName(request.getParameter("author_lname_"+number));

          if(request.getParameter("author_email_"+number)==null)
             author.setEmailAddress("");
            else
            author.setEmailAddress(request.getParameter("author_email_"+number));

          //set the author affliation
          if(request.getParameter("affiliation_content_"+number)==null)
            aff.setContent("");
            else
              aff.setContent(request.getParameter("affiliation_content_"+number));

           if(request.getParameter("affiliationCountry_"+number)==null)
            aff.setCny("");
            else
              aff.setCny(request.getParameter("affiliationCountry_"+number));

           if(request.getParameter("affiliationType_"+number)==null)
            aff.setType("");
            else
              aff.setType(request.getParameter("affiliationType_"+number));


           author.setAffiliation(aff);    //insert aff to author
          //end set the author affiliation

          authorHash.put(number,author);  //put the author to the hash table


       }
       docParameter.setNumOfAuthor(numAut);  //set the number of author parameter

      /*-----------end adding and removing author-----------------*/


              /*-----------start adding and removing references-----------------*/
            if ((numKeyword!=null)&&(numKeyword!="")){
                 numKey=Integer.parseInt(numKeyword);

            }

       // System.out.println("add Keyword :"+addKeyword);

        if ((removeKeyword!=null)&&(removeKeyword!=""))
                if (removeKeyword.equals("removeKeyword")) {
                   checkKey=true;
                   if (numKey!=0)
                       numKey=numKey-1;
               // System.out.print("number of numKeyword: "+numKey);
                }


        if ((addKeyword!=null)&&(addKeyword!=""))
                if (addKeyword.equals("addKeyword")) {
                   checkKey=true;
                   numKey=numKey+3;
                 //  System.out.print("test numRef message here: "+numKey);


                }
           //get the keyword parameter and set in the hash table
           for (int i=0; i< numKey; i++){

              String valueIndex = String.valueOf(i);
              String valueKeyword   =request.getParameter("keyword_"+valueIndex);

              if(request.getParameter("keyword_"+valueIndex)==null)
                    keywordHash.put(valueIndex,"");
                 else
                    keywordHash.put(valueIndex,valueKeyword);

       }
   docParameter.setNumOfKeyword(numKey);

   /*-----------end adding and removing references-----------------*/



%>

<form name="postDocuments" method="post" action="">
 <input type="hidden" name="numOfAuthor" value="<%=numAut%>">
 <input type="hidden" name="numOfKeyword" value="<%=numKey%>">

<p><strong><em><font color="#009999">Publisher Information</font></em></strong></p>
<table border="0" width="27%">
  <tr>
    <td width="40%"><strong>Publisher Name </strong></td>
    <td width="60%"><input type="text" name="publisherName" value="John Wiley  Sons, Ltd.">
    <!--td width="60%"><input type="text" name="publisherName" value="<%=documents.getPublisherName()%>"-->
    </td>
  </tr>
  <tr>
    <td><strong>Publisher Location</strong></td>
    <td><input type="text" name="publisherLoc" value="Chichester, UK"></td>

    <!--td><input type="text" name="publisherLoc" value="<%=documents.getPublisherLoc()%>"></td-->
  </tr>
</table>

<p>&nbsp;</p>
<p><strong><em><font color="#009999">Journal Information</font></em></strong></p>
<table width="35%" border="0">
  <tr>
    <td width="40%"><strong>Journal ID</strong></td>
    <td width="60%"><input type="text" name="journalID" value="CPE"></td>
    <!--td width="60%"><input type="text" name="journalID" value="<%=documents.getJournalID()%>"></td-->
  </tr>
  <tr>
    <td><strong>Journal Title</strong></td>

    <td><input type="text" name="journalTitle" value="Concurrency and Computation: Practice and Experience">
    <!--td><input type="text" name="journalTitle" value="<%=documents.getJournalTitle()%>"-->  lang
       <select name="journalTitleLang">
      <option selected value="ENG">ENG
          </option>
          </select>
         </td>
  </tr>
  <tr>
    <td><strong>Journal Sort Group</strong></td>
    <td><input type="text" name="journalSortGroup" value="CONCURRENCY AND COMPUTATION: PRACTICE AND EXPERIENCE"></td>
    <!--td><input type="text" name="journalSortGroup" value="<%=documents.getJournalSortGroup()%>"></td-->
  </tr>
  <tr>
    <td><strong>Journal Title Display</strong></td>
    <td><input type="text" name="journalSortDisplayer" value="Concurrency and Computation: Practice and Experience"></td>
    <!--td><input type="text" name="journalSortDisplayer" value="<%=documents.getJournalSortDisplayer()%>"></td-->
  </tr>
   <tr>
     <td height="28"><strong>ISSN</strong></td>
     <td><input type="text" name="ISSN" value="1532-0626">
    type
      <select name="ISSNType" value="<%=documents.getISSNType()%>">
      <option selected value="TX">TX</option>
      <option value="CO">CO</option>
      </select>
     </td>
   </tr>
   <tr>
    <td height="28"><strong>Journal Subject</strong></td>
     <td><input type="text" name="subject" value="Computer Science">
    </td>
  </tr>
</table>
<p><strong><em><font color="#009999">Publication Information</font></em></strong></p>
<table width="73%" height="130" border="0">
  <tr>
    <td width="27%"><strong>Volume Identification</strong></td>
    <td width="73%"><input type="text" name="VID" value="<%=documents.getVID()%>"></td>
  </tr>
  <tr>
    <td><strong>Issue Identification</strong></td>
    <td><input type="text" name="IID" value="<%=documents.getIID()%>"></td>
  </tr>
  <tr>
    <td height="71"><strong>Cover Date</strong></td>
    <td><p>Year
         <select name="year">
          <option selected value="2003">2003</option>
          <option value="2000">2000</option>
          <option value="2001">2001</option>
          <option value="2002">2002</option>
      </select>
      Month
      <select name="month">
        <option selected value="Jan">Jan</option>
        <option value="Feb">Feb</option>
        <option value="Jan">Jan</option>
        <option value="March">March</option>
        <option value="Apr">Apr</option>
        <option value="May">May</option>
        <option value="June">June</option>
        <option value="July">July</option>
        <option value="Aug">Aug</option>
        <option value="Sep">Sep</option>
        <option value="Oct">Oct</option>
        <option value="Nov">Nov</option>
        <option value="Dec">Dec</option>
            </select>
      Day
      <select name="day">
         <option selected value="1">1</option>
         <option value="2">2</option>
         <option value="3">3</option>
         <option value="4">4</option>
         <option value="5">6</option>
         <option value="7">7</option>
         <option value="8">8</option>
         <option value="9">9</option>
         <option value="10">10</option>
         <option value="11">11</option>
         <option value="12">12</option>
         <option value="13">13</option>
         <option value="14">14</option>
         <option value="15">15</option>
         <option value="16">16</option>
         <option value="17">17</option>
         <option value="18">2</option>
         <option value="19">19</option>
         <option value="20">20</option>
         <option value="21">21</option>
         <option value="22">22</option>
         <option value="23">23</option>
         <option value="24">24</option>
         <option value="25">25</option>
         <option value="26">26</option>
         <option value="27">27</option>
         <option value="28">28</option>
         <option value="29">29</option>
         <option value="30">30</option>
         <option value="31">31</option>


            </select>
      </p>
      <p>End Year
        <select name="endYear">

          <option selected value="2003">2003</option>
          <option value="0000">0000</option>
          <option value="2000">2001</option>
          <option value="2001">2001</option>
          <option value="2002">2002</option>
        </select>
      End Month
      <select name="endMonth">
        <option selected value="00">00</option>
        <option value="Jan">Jan</option>
        <option value="Feb">Feb</option>
        <option value="Jan">Jan</option>
        <option value="March">March</option>
        <option value="Apr">Apr</option>
        <option value="May">May</option>
        <option value="June">June</option>
        <option value="July">July</option>
        <option value="Aug">Aug</option>
        <option value="Sep">Sep</option>
        <option value="Oct">Oct</option>
        <option value="Nov">Nov</option>
        <option value="Dec">Dec</option>
      </select>
      End Day
      <select name="endDay">
         <option selected value="0">0</option>
         <option value="1">1</option>
         <option value="2">2</option>
         <option value="3">3</option>
         <option value="4">4</option>
         <option value="5">6</option>
         <option value="7">7</option>
         <option value="8">8</option>
         <option value="9">9</option>
         <option value="10">10</option>
         <option value="11">11</option>
         <option value="12">12</option>
         <option value="13">13</option>
         <option value="14">14</option>
         <option value="15">15</option>
         <option value="16">16</option>
         <option value="17">17</option>
         <option value="18">2</option>
         <option value="19">19</option>
         <option value="20">20</option>
         <option value="21">21</option>
         <option value="22">22</option>
         <option value="23">23</option>
         <option value="24">24</option>
         <option value="25">25</option>
         <option value="26">26</option>
         <option value="27">27</option>
         <option value="28">28</option>
         <option value="29">29</option>
         <option value="30">30</option>
         <option value="31">31</option>
       </select>
      </p></td>
  </tr>

</table>
<p><strong><em><font color="#009999">Article Content</font></em></strong></p>
<p><em><strong><font color="#009999" size="2">Article Information</font></strong></em></p>
<table width="60%" border="0">
  <tr>
    <td width="20%"><strong>Article Identification</strong></td>
    <td width="80%"><input type="text" name="articleIdentification" value="<%=documents.getArticleIdentification()%>"></td>
  </tr>
  <tr>
    <td><strong>Digital Object Identifier(URI)</strong></td>
    <td><input type="text" name="DOIURI" value="<%=documents.getDOIURI()%>">
    origin <select name="DOIOrigin">
    <option selected value="wiley">wiley</option>
    </select>  registered <select name="DOIRegistered"> <option selected value="yes">yes</option>
         <option value="no">no</option>
        </select>

    level <select name="DOILevel"> <option selected value="article">article</option>
        </select>  </td>
  </tr>
  <tr>
    <td><strong>Article Type</strong></td>
    <td><select name="articleType">
      <option selected value="RA">RA</option>
          <option value="other">other</option>
  </select></td></tr>
  <tr>
    <td><strong>Category</strong></td>
    <td><input type="text" name="category" value="<%=documents.getCategory()%>"></td>
  </tr>
</table>
<p><em><strong><font color="#009999" size="2">Article Title </font></strong></em></p>
<table width="60%" border="0">
  <tr>
    <td width="20%"><strong>Article Title</strong></td>
    <td width="80%">
      <textarea cols="40" rows="5" name="articleTitle"><%=documents.getArticleTitle()%></textarea>
     </td>
  </tr>
</table>

<p><em><strong><font color="#009999" size="2">Author Group</font></strong></em></p>
<table width="68%" border="0" bordercolor="#99CCFF" bgcolor="#9999FF">


<%
////////////////////

    //  System.out.println("number of author is:"+authorHash.size());
         //get the authors  from hash table
         for (int j=0;  j<authorHash.size(); j++) {
                    //author
                    Author author = new Author();
                    String num = String.valueOf(j);
                    author =(Author)authorHash.get(num);

                   //affiliation
                   Affiliation aff = new Affiliation();
                   aff=author.getAffiliation();

         %>
      <tr>

        <td width="11%" rowspan="5"><strong><font color="#660000">Author <%=j%>-)</font></strong>
        </td>
               <%  if (j==0) {%>
                 <td width="31%"><strong>First Name</strong> *
               <% }
                   else { %> <td width="31%"><strong>First Name</strong>
               <% }%>
               </td>

               <td width="58%">
               <input name="author_fname_<%=j%>"  value="<%=author.getFirstName()%>" type="text" size="50" maxlength="200">
               </td>
     </tr>

     <tr>
               <%  if (j==0) {%>
               <td><strong>Last Name</strong> *
                   <% }
                   else { %> <td width="31%"><strong>Last Name</strong>
               <% }%>
               </td>
               <td><input name="author_lname_<%=j%>" value="<%=author.getLastName()%>" type="text" size="50" maxlength="200">
               </td>
     </tr>
     <tr>
               <%  if (j==0) {%>
               <td><strong>Email</strong> *
                   <% }
                   else { %> <td width="31%"><strong>Email</strong>
               <% }%>
               </td>
               <td><input name="author_email_<%=j%>" value="<%=author.getEmailAddress()%>" type="text" size="50" maxlength="200">
               </td>
     </tr>
            <tr>
               <td><strong>Affiliation</strong>
               </td>
               <td><input name="affiliation_content_<%=j%>" value="<%=aff.getContent()%>" type="text" size="50" maxlength="200">
               </td>
            </tr>
            <tr>
                 <td>type
                    <select name="affiliationType_<%=j%>">
                      <option selected value="<%=aff.getType()%>"><%=aff.getType()%></option>
                      <option  value="ORG">ORG</option>
                    </select>
                 </td>
                 <td>country
                    <select name="affiliationCountry_<%=j%>">
                       <option selected value="<%=aff.getCny()%>"><%=aff.getCny()%></option>
                      <option  value="USA">USA</option>
                      <option  value="AU">AU</option>
                      <option  value="AT">AT</option>
                      <option  value="CA">CA</option>
                      <option  value="CH">CH</option>
                      <option  value="GB">GB</option>
                      <option  value="FR">FR</option>
                      <option  value="HK">HK</option>
                      <option  value="PL">PL</option>
                      <option  value="DE">DE</option>
                      <option  value="IL">IL</option>
                      <option  value="IN">IN</option>
                      <option  value="IE">IE</option>
                      <option  value="IT">IT</option>
                      <option  value="JP">JP</option>
                      <option  value="KR">KR</option>
                      <option  value="NE">NE</option>
                      <option  value="ES">ES</option>
                      <option  value="EE">EE</option>
                    </select>
                </td>
             </tr>

       <%// }
          }

         // if ((!checkRef)&&(check))
         authorHash.clear();
///////////////////////////////
%>
 <tr>
  <td><input type="submit" name="addAuthor" class="button" value="addAuthor"></td>
<%
 if (numAut==1){%>

         <td><input name="removeAuthor" disabled value="removeAuthor" class="button" type="submit"></td>
           <% } else {%>
         <td><input name="removeAuthor"  value="removeAuthor" class="button" type="submit"></td>
           <%} %>
 </tr>
</table>

<p><em><strong><font color="#009999" size="2">Abstract</font></strong></em></p>
<strong>language</strong><select name="absractLanguage">
  <option selected value="ENG">ENG</option>
  </select>
<table width="60%" border="0">
  <tr>
    <td width="22%"><strong>Abstract</strong></td>
    <td width="78%">
      <textarea cols="60" rows="12" name="abstractParam"><%=documents.getAbstractParam()%></textarea>
    </td>
  </tr>
</table>
<p><em><strong><font color="#009999" size="2">Keywords</font></strong></em></p>
<!-- keywords sections --->
 <table width="62%" border="1" align="left" cellspacing="0" bordercolor="#99CCFF" bgcolor="#9999FF">
         <% System.out.println("number of reference is:"+keywordHash.size());
            //if (checkRef){
         String keywordValue="";
         for (int k=0;  k<keywordHash.size(); k++) {
            String keyval = String.valueOf(k);
            keywordValue =(String)keywordHash.get(keyval);
            int m=k;
            m++;
            %>
     <tr>
      <td width="19%" height="26"><strong>Keyword <%=m%> </strong></td>
      <td width="81%" colspan="2">

      <input name="keyword_<%=k%>" type="text" size="50" value="<%=keywordValue%>"></td>
      </tr>
      <% }

         keywordHash.clear();

      %>
      <tr>
        <td><input name="addKeyword" value="addKeyword" class="button" type="submit"></td>

      <% if (numKey==0) { %>
        <td><input name="removeKeyword" disabled value="removeKeyword" class="button" type="submit"></td>
         <%} else { %>
             <td><input name="removeKeyword"   value="removeKeyword" class="button" type="submit"></td>
         <% } %>
      </tr>
     </table>
<!--end add or remove keyword section -->

<p>&nbsp;</p>
<input type="submit" name="sendDoc" onClick="return checkform_onsubmit()" value="POST">

<p><em><strong><font color="#009999" size="2"></font></strong></em></p>
</form>
</body>
</html>
