package commgrids.nuggets.wiley;

import java.util.StringTokenizer;
import java.util.Vector;


/**
 * DOCUMENT ME!
 *
 * @version $Revision: 1.2 $
 * @author $author$
 */
public class User extends Login {
    private String  adminName      = "";
    private String  email          = "";
    private String  firstName      = "";
    private String  lastName       = "";
    private String  role           = "user";
    private String  superAdminName = "";
    private String  topic          = "";
    private boolean admin          = false;
    private boolean superadmin     = false;

    /**
     *
     * @param aAdmin - the new value for admin
     */
    public void setAdmin(boolean aAdmin) {
        admin = aAdmin;
    }

    /**
     *
     * @return true if admin is set to true.
     */
    public boolean isAdmin() {
        return admin;
    }

    /**
     *
     * @param aAdminname - the new value for adminname
     */
    public void setAdminName(String aAdminname) {
        adminName = aAdminname;
    }

    /**
     *
     * @return the String value of adminname.
     */
    public String getAdminName() {
        return adminName;
    }

    /**
     *
     * @param aEmail - the new value for email
     */
    public void setEmail(String aEmail) {
        email = aEmail;
    }

    /**
     *
     * @return the String value of email.
     */
    public String getEmail() {
        return email;
    }

    /**
     *
     * @param aFirstName - the new value for firstName
     */
    public void setFirstName(String aFirstName) {
        firstName = aFirstName;
    }

    /**
     *
     * @return the String value of firstName.
     */
    public String getFirstName() {
        return firstName;
    }

    /**
     *
     * @param aLastName - the new value for lastName
     */
    public void setLastName(String aLastName) {
        lastName = aLastName;
    }

    /**
     *
     * @return the String value of lastName.
     */
    public String getLastName() {
        return lastName;
    }

    /**
     *
     * @param aRole - the new value for role
     */
    public void setRole(String aRole) {
        role = aRole;
    }

    /**
     *
     * @return the String value of role.
     */
    public String getRole() {
        return role;
    }

    /**
     *
     * @param aSuperadmin - the new value for superadmin
     */
    public void setSuperAdmin(boolean aSuperadmin) {
        superadmin = aSuperadmin;
    }

    /**
     *
     * @return true if superadmin is set to true.
     */
    public boolean isSuperAdmin() {
        return superadmin;
    }

    /**
     *
     * @param aSuperAdminName - the new value for superAdminName
     */
    public void setSuperAdminName(String aSuperAdminName) {
        superAdminName = aSuperAdminName;
    }

    /**
     *
     * @return the String value of superAdminName.
     */
    public String getSuperAdminName() {
        return superAdminName;
    }

    /**
     *
     * @param aTopic - the new value for topic
     */
    public void setTopic(String aTopic) {
        topic = aTopic;
    }

    /**
     *
     * @return the String value of topic.
     */
    public String getTopic() {
        return topic;
    }

    /**
     * DOCUMENT ME!
     *
     * @param array DOCUMENT ME!
     *
     * @return DOCUMENT ME!
     */
    public Vector arrayToVector(Object[] array) {
        Vector result = new Vector();

        for (int i = 0; i < array.length; i++) {
            result.add(array[i]);
        }

        return result;
    }

    /**
     * DOCUMENT ME!
     *
     * @param temp DOCUMENT ME!
     *
     * @return DOCUMENT ME!
     */
    public int compareByAdminName(User temp) {
        int result = this.adminName.compareTo(temp.adminName);

        if (result < 0) {
            return -1;
        } else if (result > 0) {
            return 1;
        } else {
            return 0;
        }
    }

    /**
     * DOCUMENT ME!
     *
     * @param temp DOCUMENT ME!
     *
     * @return DOCUMENT ME!
     */
    public int compareByEmail(User temp) {
        int result = this.email.compareTo(temp.email);

        if (result < 0) {
            return -1;
        } else if (result > 0) {
            return 1;
        } else {
            return 0;
        }
    }

    /**
     * DOCUMENT ME!
     *
     * @param temp DOCUMENT ME!
     *
     * @return DOCUMENT ME!
     */
    public int compareByFirstName(User temp) {
        int result = this.firstName.compareTo(temp.firstName);

        if (result < 0) {
            return -1;
        } else if (result > 0) {
            return 1;
        } else {
            return 0;
        }
    }

    /**
     * DOCUMENT ME!
     *
     * @param temp DOCUMENT ME!
     *
     * @return DOCUMENT ME!
     */
    public int compareByLastName(User temp) {
        int result = this.lastName.compareTo(temp.lastName);

        if (result < 0) {
            return -1;
        } else if (result > 0) {
            return 1;
        } else {
            return 0;
        }
    }

    /**
     * DOCUMENT ME!
     *
     * @param temp DOCUMENT ME!
     *
     * @return DOCUMENT ME!
     */
    public int compareByTopic(User temp) {
        int result = this.topic.compareTo(temp.topic);

        if (result < 0) {
            return -1;
        } else if (result > 0) {
            return 1;
        } else {
            return 0;
        }
    }

    /**
     * DOCUMENT ME!
     *
     * @param temp DOCUMENT ME!
     *
     * @return DOCUMENT ME!
     */
    public int compareByUserName(User temp) {
        int result = super.getUserName()
                          .compareTo(temp.getUserName());

        if (result < 0) {
            return -1;
        } else if (result > 0) {
            return 1;
        } else {
            return 0;
        }
    }

    /**
     * DOCUMENT ME!
     */
    public void constructUserInfo() {
        super.database = new Database();
        super.database.getUserInfo(this);
    }

    /**
     * DOCUMENT ME!
     *
     * @param args DOCUMENT ME!
     */
    public static void main(String[] args) {
        User user = new User();
        user.setUserName("akaplan");
        user.setPassword("akaplan");
        user.constructUserInfo();
     //   System.out.println("First Name " + user.getFirstName());
     //   System.out.println("Last Name " + user.getLastName());
     //  System.out.println("email " + user.getEmail());
    }

    /**
     * DOCUMENT ME!
     *
     * @param vector DOCUMENT ME!
     *
     * @return DOCUMENT ME!
     */
    public Object[] vectorToArray(Vector vector) {
        Object[] array = new Object[vector.size()];

        for (int i = 0; i < vector.size(); i++) {
            array[i] = vector.get(i);
        }

        return array;
    }
}