package commgrids.nuggets.wiley.rss.settings;

import com.sun.tools.doclets.ImplementedMethods;

import java.text.SimpleDateFormat;

import java.util.*;


/**
 * DOCUMENT ME!
 *
 * @author $author$
 * @version $Revision: 1.1.1.1 $
 */
public class RSSElement implements Comparable, Comparator {
  private static int categoryLength  = 255;
  private static int authorLength    = 255;
  private static int dateLength      = 255;
  private static int articleIdLength = 255;
  private static int linkLength      = 255;
  private static int articleTitleLength = 255;
  private String articleId    = null;
  private String articleTitle = null;
  private String author   = null;
  private String category = null;
  private String date     = null;
  private String link     = null;
  private int articleIdOrder    = 0;
  private int articleTitleOrder = 0;
  private int authorOrder   = 0;
  private int categoryOrder = 0;
  private int dateOrder     = 0;
  private int linkOrder     = 0;

  //private String[]

  /**
   * Creates a new RSSElement object.
   */
  public RSSElement() {}

  /**
   * DOCUMENT ME!
   *
   * @param ArticleIdLength_1 - the new value for articleIdLength
   */
  public static void setArticleIdLength(int ArticleIdLength_1) {
    articleIdLength = ArticleIdLength_1;
  }

  /**
   * DOCUMENT ME!
   *
   * @return the int value of articleIdLength.
   */
  public static int getArticleIdLength() {
    return articleIdLength;
  }

  /**
   * DOCUMENT ME!
   *
   * @param ArticleTitleLength_1 - the new value for articleTitleLength
   */
  public static void setArticleTitleLength(int ArticleTitleLength_1) {
    articleTitleLength = ArticleTitleLength_1;
  }

  /**
   * DOCUMENT ME!
   *
   * @return the int value of articleTitleLength.
   */
  public static int getArticleTitleLength() {
    return articleTitleLength;
  }

  /**
   * DOCUMENT ME!
   *
   * @param AuthorLength_1 - the new value for authorLength
   */
  public static void setAuthorLength(int AuthorLength_1) {
    authorLength = AuthorLength_1;
  }

  /**
   * DOCUMENT ME!
   *
   * @return the int value of authorLength.
   */
  public static int getAuthorLength() {
    return authorLength;
  }

  /**
   * DOCUMENT ME!
   *
   * @param CategoryLength_1 - the new value for categoryLength
   */
  public static void setCategoryLength(int CategoryLength_1) {
    categoryLength = CategoryLength_1;
  }

  /**
   * DOCUMENT ME!
   *
   * @return the int value of categoryLength.
   */
  public static int getCategoryLength() {
    return categoryLength;
  }

  /**
   * DOCUMENT ME!
   *
   * @param DateLength_1 - the new value for dateLength
   */
  public static void setDateLength(int DateLength_1) {
    dateLength = DateLength_1;
  }

  /**
   * DOCUMENT ME!
   *
   * @return the int value of dateLength.
   */
  public static int getDateLength() {
    return dateLength;
  }

  /**
   * DOCUMENT ME!
   *
   * @param LinkLength_1 - the new value for linkLength
   */
  public static void setLinkLength(int LinkLength_1) {
    linkLength = LinkLength_1;
  }

  /**
   * DOCUMENT ME!
   *
   * @return the int value of linkLength.
   */
  public static int getLinkLength() {
    return linkLength;
  }

  /**
   * DOCUMENT ME!
   *
   * @param ArticleId_1 - the new value for articleId
   */
  public void setArticleId(String ArticleId_1) {
    articleId = ArticleId_1;
  }

  /**
   * DOCUMENT ME!
   *
   * @return the String value of articleId.
   */
  public String getArticleId() {
    return articleId;
  }

  /**
   * DOCUMENT ME!
   *
   * @param ArticleIdOrder_1 - the new value for articleIdOrder
   */
  public void setArticleIdOrder(int ArticleIdOrder_1) {
    articleIdOrder = ArticleIdOrder_1;
  }

  /**
   * DOCUMENT ME!
   *
   * @return the int value of articleIdOrder.
   */
  public int getArticleIdOrder() {
    return articleIdOrder;
  }

  /**
   * DOCUMENT ME!
   *
   * @param ArticleTitle_1 - the new value for articleTitle
   */
  public void setArticleTitle(String ArticleTitle_1) {
    articleTitle = ArticleTitle_1;
  }

  /**
   * DOCUMENT ME!
   *
   * @return the String value of articleTitle.
   */
  public String getArticleTitle() {
    return articleTitle;
  }

  /**
   * DOCUMENT ME!
   *
   * @param ArticleTitleOrder_1 - the new value for articleTitleOrder
   */
  public void setArticleTitleOrder(int ArticleTitleOrder_1) {
    articleTitleOrder = ArticleTitleOrder_1;
  }

  /**
   * DOCUMENT ME!
   *
   * @return the int value of articleTitleOrder.
   */
  public int getArticleTitleOrder() {
    return articleTitleOrder;
  }

  /**
   * DOCUMENT ME!
   *
   * @param Author_1 - the new value for author
   */
  public void setAuthor(String Author_1) {
    author = Author_1;
  }

  /**
   * DOCUMENT ME!
   *
   * @return the String value of author.
   */
  public String getAuthor() {
    return author;
  }

  /**
   * DOCUMENT ME!
   *
   * @param AuthorOrder_1 - the new value for authorOrder
   */
  public void setAuthorOrder(int AuthorOrder_1) {
    authorOrder = AuthorOrder_1;
  }

  /**
   * DOCUMENT ME!
   *
   * @return the int value of authorOrder.
   */
  public int getAuthorOrder() {
    return authorOrder;
  }

  /**
   * DOCUMENT ME!
   *
   * @param Category_1 - the new value for category
   */
  public void setCategory(String Category_1) {
    category = Category_1;
  }

  /**
   * DOCUMENT ME!
   *
   * @return the String value of category.
   */
  public String getCategory() {
    return category;
  }

  /**
   * DOCUMENT ME!
   *
   * @param CategoryOrder_1 - the new value for categoryOrder
   */
  public void setCategoryOrder(int CategoryOrder_1) {
    categoryOrder = CategoryOrder_1;
  }

  /**
   * DOCUMENT ME!
   *
   * @return the int value of categoryOrder.
   */
  public int getCategoryOrder() {
    return categoryOrder;
  }

  /**
   * DOCUMENT ME!
   *
   * @param Date_1 - the new value for date
   */
  public void setDate(String Date_1) {
    date = Date_1;
  }

  /**
   * DOCUMENT ME!
   *
   * @return the String value of date.
   */
  public String getDate() {
    return date;
  }

  /**
   * DOCUMENT ME!
   *
   * @param DateOrder_1 - the new value for dateOrder
   */
  public void setDateOrder(int DateOrder_1) {
    dateOrder = DateOrder_1;
  }

  /**
   * DOCUMENT ME!
   *
   * @return the int value of dateOrder.
   */
  public int getDateOrder() {
    return dateOrder;
  }

  /**
   * DOCUMENT ME!
   *
   * @param Link_1 - the new value for link
   */
  public void setLink(String Link_1) {
    link = Link_1;
  }

  /**
   * DOCUMENT ME!
   *
   * @return the String value of link.
   */
  public String getLink() {
    return link;
  }

  /**
   * DOCUMENT ME!
   *
   * @param LinkOrder_1 - the new value for linkOrder
   */
  public void setLinkOrder(int LinkOrder_1) {
    linkOrder = LinkOrder_1;
  }

  /**
   * DOCUMENT ME!
   *
   * @return the int value of linkOrder.
   */
  public int getLinkOrder() {
    return linkOrder;
  }

  /**
   * DOCUMENT ME!
   *
   * @param obj DOCUMENT ME!
   * @param obj1 DOCUMENT ME!
   *
   * @return DOCUMENT ME!
   */
  public int compare(Object obj,
                     Object obj1) {
    RSSElement temp   = (RSSElement) obj;
    RSSElement temp1  = (RSSElement) obj1;
    int        result = temp.link.compareToIgnoreCase(temp1.link);

    if (result < 0) {
      return -1;
    } else if (result > 0) {
      return 1;
    } else {
      return 0;
    }
  }

  /**
   * DOCUMENT ME!
   *
   * @param obj DOCUMENT ME!
   *
   * @return DOCUMENT ME!
   */
  public int compareByArticleId(Object obj) {
    RSSElement temp   = (RSSElement) obj;
    int        result = this.articleId.compareToIgnoreCase(temp.articleId);

    if (result < 0) {
      return -1;
    } else if (result > 0) {
      return 1;
    } else {
      return 0;
    }
  }

  /**
   * DOCUMENT ME!
   *
   * @param obj DOCUMENT ME!
   *
   * @return DOCUMENT ME!
   */
  public int compareByArticleTitle(Object obj) {
    RSSElement temp   = (RSSElement) obj;
    int        result = this.articleTitle.compareToIgnoreCase(temp.articleTitle);

    if (result < 0) {
      return -1;
    } else if (result > 0) {
      return 1;
    } else {
      return 0;
    }
  }

  /**
   * DOCUMENT ME!
   *
   * @param obj DOCUMENT ME!
   *
   * @return DOCUMENT ME!
   */
  public int compareByAuthor(Object obj) {
    RSSElement temp   = (RSSElement) obj;
    int        result = this.author.compareToIgnoreCase(temp.author);

    if (result < 0) {
      return -1;
    } else if (result > 0) {
      return 1;
    } else {
      return 0;
    }
  }

  /**
   * DOCUMENT ME!
   *
   * @param obj DOCUMENT ME!
   *
   * @return DOCUMENT ME!
   */
  public int compareByCategory(Object obj) {
    RSSElement temp   = (RSSElement) obj;
    int        result = this.category.compareToIgnoreCase(temp.category);

    if (result < 0) {
      return -1;
    } else if (result > 0) {
      return 1;
    } else {
      return 0;
    }
  }

  /**
   * DOCUMENT ME!
   *
   * @param obj DOCUMENT ME!
   *
   * @return DOCUMENT ME!
   */
  public int compareByDate(Object obj) {
    try {
      RSSElement       temp     = (RSSElement) obj;
      SimpleDateFormat sdfInput = new SimpleDateFormat("mm/dd/yyyy");
      Date             date     = sdfInput.parse(this.date);
      Date             date1    = sdfInput.parse(temp.date);
      int              result   = date.compareTo(date1);

      if (result < 0) {
        return -1;
      } else if (result > 0) {
        return 1;
      } else {
        return 0;
      }
    } catch (Exception ex) {
      ex.printStackTrace();
    }

    return -1;
  }

  /**
   * DOCUMENT ME!
   *
   * @param obj DOCUMENT ME!
   *
   * @return DOCUMENT ME!
   */
  public int compareByLink(Object obj) {
    RSSElement temp   = (RSSElement) obj;
    int        result = this.link.compareToIgnoreCase(temp.link);

    if (result < 0) {
      return -1;
    } else if (result > 0) {
      return 1;
    } else {
      return 0;
    }
  }

  /**
   * DOCUMENT ME!
   *
   * @param obj DOCUMENT ME!
   *
   * @return DOCUMENT ME!
   */
  public int compareTo(Object obj) {
    RSSElement temp   = (RSSElement) obj;
    int        result = this.articleId.compareToIgnoreCase(temp.articleId);

    if (result < 0) {
      return -1;
    } else if (result > 0) {
      return 1;
    } else {
      return 0;
    }
  }
}
