/*
   ////////////////////////////////////////////////////////////////////
   //  Module Name : wiley document(WILEY DOCUMENTS)                 //
   //  Page Name   : Parameter.java                                  //
   //  ver 0.9                                                          //
   //  Platform:      ...                                            //
   //  Application:   Community Grids Labs, Wiley Document Project   //
   //  Author:        Ali Kaplan,  alikapla@cs.indiana.edu           //
   //                 Ahmet Topcu  atopcu@cs.indiana.edu             //
   //                 Community Grids Labs, Indiana University       //
   ////////////////////////////////////////////////////////////////////
   /////////////////////////////////////////////////////////////////////////////
       This java class get and set the number of author and number of references
       defined in the postDocument.jsp pages.
       public int getNumOfAuthor ()
       public int getNumOfReference ()
       public void setNumOfAuthor (int aNumOfAuthor)
       public void setNumOfReference (int aNumOfReference)
   /////////////////////////////////////////////////////////////////////////////
   /////////////////////////////////////////////////////////////////////
   //                      maintenance page                           //
   /////////////////////////////////////////////////////////////////////
   //  Build Process                                                  //
   //                                                                 //
   // Files Required:                                                 //
   // 1)postDocument.jsp,                                             //
   /////////////////////////////////////////////////////////////////////
       Maintenance History
       ===================
         ver 0.9 : Nov 12 2003
           - first release
       Planned Modifications:
       ======================
       If new parameter defined, number of parameter can be defined in
       this class.
 */
package commgrids.nuggets.wiley.util;

/**
 * DOCUMENT ME!
 *
 * @author $author$
 * @version $Revision$
 */
public class Parameter {
    private int numOfAuthor  = 1;
    private int numOfKeyword = 1;

    /**
     * Creates a new Parameter object.
     */
    public Parameter () {
    }

    /**
     * DOCUMENT ME!
     *
     * @param aNumOfAuthor - the new value for numOfAuthor
     */
    public void setNumOfAuthor (int aNumOfAuthor) {
        numOfAuthor = aNumOfAuthor;
    }

    /**
     * DOCUMENT ME!
     *
     * @return the int value of numOfAuthor.
     */
    public int getNumOfAuthor () {
        return numOfAuthor;
    }

    /**
     * DOCUMENT ME!
     *
     * @param aNumOfKeyword - the new value for numOfKeyword
     */
    public void setNumOfKeyword (int aNumOfKeyword) {
        numOfKeyword = aNumOfKeyword;
    }

    /**
     * DOCUMENT ME!
     *
     * @return the int value of numOfKeyword.
     */
    public int getNumOfKeyword () {
        return numOfKeyword;
    }

    /**
     * DOCUMENT ME!
     *
     * @param args DOCUMENT ME!
     */
    public static void main (String[] args) {
        Parameter parameter1 = new Parameter();
    }
}
