package commgrids.nuggets.wiley;

/**
 * DOCUMENT ME!
 *
 * @version $Revision: 1.1.1.1 $
 * @author $author$
 */
public class Login {//implements LoginInterface{
    protected Database database = null;
    private String   password      = "";
    private String   passwordError = "";
    private String   userName      = "";
    private String   userNameError = "";
    private boolean  firstTry      = true;
    private boolean  isValid       = false;

    /**
    *
    * @param aFirstTry - the new value for firstTry
    */
    public void setFirstTry(boolean aFirstTry) {
        firstTry = aFirstTry;
    }

    /**
    *
    * @return true if firstTry is set to true.
    */
    public boolean isFirstTry() {
        return firstTry;
    }

    /**
    *
    * @return true if isValid is set to true.
    */
    public boolean isValid() {
        return isValid;
    }

    /**
    *
    * @param aPassword - the new value for password
    */
    public void setPassword(String aPassword) {
        password = aPassword;
    }

    /**
    *
    * @return the String value of password.
    */
    public String getPassword() {
        return password;
    }

    /**
    *
    * @param aPasswordError - the new value for passwordError
    */
    public void setPasswordError(String aPasswordError) {
        passwordError = aPasswordError;
    }

    /**
    *
    * @return the String value of passwordError.
    */
    public String getPasswordError() {
        return passwordError;
    }

    /**
    *
    * @param aUserName - the new value for userName
    */
    public void setUserName(String aUserName) {
        userName = aUserName;
    }

    /**
    *
    * @return the String value of userName.
    */
    public String getUserName() {
        return userName;
    }

    /**
    *
    * @param aUserNameError - the new value for userNameError
    */
    public void setUserNameError(String aUserNameError) {
        userNameError = aUserNameError;
    }

    /**
    *
    * @return the String value of userNameError.
    */
    public String getUserNameError() {
        return userNameError;
    }

    /**
     * DOCUMENT ME!
     */
    public void clearErrors() {
        userNameError = "";
        passwordError = "";
    }

    /**
     * DOCUMENT ME!
     *
     * @param args DOCUMENT ME!
     */
    public static void main(String[] args) {
        Login login = new Login();

        login.setUserName("akaplan");
        login.setPassword("akaplan1");

        System.out.println("Valid " + login.validate());
        System.out.println("Username Error: " + login.getUserNameError());
        System.out.println("Password Error: " + login.getPasswordError());
    }

    /**
     * DOCUMENT ME!
     *
     * @return DOCUMENT ME!
     */
    public boolean validate() {
        clearErrors();
        database = new Database();

        isValid = database.loginValidate(this);
        database = null;
        return isValid;
    }

    /**
    *
    * @param aIsValid - the new value for isValid
    */
    private void setIsValid(boolean aIsValid) {
        isValid = aIsValid;
    }
}