package commgrids.nuggets.wiley;

import java.net.URLEncoder;

import java.util.Comparator;
import java.util.Vector;
import java.util.*;

//import commgrids.nuggets.wiley.sort.SortAuthor;
//import metadatabrowser.sort.SortStringURI;


/**
 * DOCUMENT ME!
 *
 * @version $Revision: 1.2 $
 * @author $author$
 */


//added 11/24/03
class Comparer implements Comparator {
        public int compare(Object obj1, Object obj2)
        {
          String str1="";
          String str2="";
          int index1=obj1.toString().indexOf("-"); //check obj1 to have "-" char
          int index2=obj2.toString().indexOf("-"); //check obj1 to have "-" char
          //System.out.println("index1: " +index1);
          //System.out.println("index2: " +index2);
          if (index1!=-1) { //check index1
            str1=obj1.toString().substring(0,index1);
            System.out.println("str1 :" +str1);
          } else
            str1=obj1.toString();


          if (index2!=-1) {  //check index2
            str2=obj2.toString().substring(0,index2);
            //System.out.println("str2 :" +str2);
         } else
            str2=obj2.toString();

          int i1 = Integer.parseInt(str1);
          int i2 = Integer.parseInt(str2);

         //int i1 = Integer.parseInt((String)obj1);
          //int i2 = Integer.parseInt((String)obj2);

//                int i1 = ((Integer)obj1).intValue();
//                int i2 = ((Integer)obj2).intValue();

                return Math.abs(i1) - Math.abs(i2);
         } //end compare function
}



////////////////
public class TopicThreaded {
    private String  childSpace     = null;
    private String  data           = "";
    private String  mySpace        = null;
    private String  subSpace       = ""; //"&nbsp;&nbsp;&nbsp;";
    private Vector  hashTable      = null;
    private Vector  threaded       = null;
    private Vector  threadedTopics = null;
    private boolean found          = false;
    private int     index          = 0;

    /**
     * Creates a new TopicThreaded object.
     */
    public TopicThreaded() {
        threaded  = new Vector();
        hashTable = new Vector();
        index     = 0;
    }

    /**
     *
     * @param aData - the new value for data
     */
    public void setData(String aData) {
        data = aData;
    }

    /**
     *
     * @return the String value of data.
     */
    public String getData() {
        return data;
    }

    /**
     * DOCUMENT ME!
     *
     * @param str DOCUMENT ME!
     * @param begin DOCUMENT ME!
     * @param end DOCUMENT ME!
     *
     * @return DOCUMENT ME!
     */
    public int getIntegerFromString(String str,
                                    int    begin,
                                    int    end) {
        String  number       = "0";
        boolean isFirstDigit = false;

        //System.out.println("Number " + str + " " + begin + " " + end);
        for (int i = begin; i < end; i++) {
            //System.out.println(Character.isDigit(str.charAt(i))+"------------------------------------->"
            // + number);
            if (Character.isDigit(str.charAt(i))) {
                number += str.charAt(i);
                isFirstDigit = true;
            } else if (isFirstDigit) {
                break;
            }
        }

        return Integer.parseInt(number);
    }

    /**
     * DOCUMENT ME!
     *
     * @param topicName DOCUMENT ME!
     *
     * @return DOCUMENT ME!
     */
    public int getLevel(String topicName) {
        int bindex = 0;
        int count = 0;

        while ((bindex = topicName.indexOf("/", bindex) + 1) > 0) {
            count++;
        }

        return count;
    }

    /**
     * DOCUMENT ME!
     *
     * @param topicName DOCUMENT ME!
     *
     * @return DOCUMENT ME!
     */
    public String getName(String topicURI) {
        if (topicURI.indexOf("/", 0) > 0) {
            return topicURI.substring(topicURI.lastIndexOf("/") + 1);
        } else {
            return topicURI;
        }
    }

    /**
     * DOCUMENT ME!
     *
     * @param topicURI DOCUMENT ME!
     *
     * @return DOCUMENT ME!
     */
    public String getParentName(String topicURI) {
        if (topicURI.indexOf("/", 0) > 0) {
            return topicURI.substring(0,
                                      topicURI.lastIndexOf("/"));
        } else {
            return "";
        }
    }

    /**
     *
     * @param aThreaded - the new value for threaded
     */
    public void setThreaded(Vector aThreaded) {
        threaded = aThreaded;
    }

    /**
     *
     * @return the Vector value of threaded.
     */
    public Vector getThreaded() {
        return threaded;
    }

    /**
    *
    * @param aThreadedTopics - the new value for threadedTopics
    */
    public void setThreadedTopics(Vector aThreadedTopics) {
        threadedTopics = aThreadedTopics;
    }

    /**
    *
    * @return the Vector value of threadedTopics.
    */
    public Vector getThreadedTopics() {
        return threadedTopics;
    }

    /**
     * DOCUMENT ME!
     *
     * @param topics DOCUMENT ME!
     */
    public void convertArrayToThreaded(String[] topics) {
      //added 11/24/03
     /* Vector topicVec= new Vector();
      Collections.sort(threaded, new Comparer());
      for (int i = 0; i < threaded.size(); i++) {
              String e=((String)threaded.elementAt(i));
              //System.out.println(e);
      }
      */


        for (int i = 0; i < topics.length; i++) {
            found = false;

            /*----------------BEGIN DEBUG------------------*
             System.out.println("Topic is " + topics[i]);
            /*----------------END DEBUG--------------------*/
            int    lastSlash = topics[i].lastIndexOf("/");
            int    level     = getLevel(topics[i]);
            String topicName = null;
            String parent    = null;

            if (lastSlash > 0) {
                topicName = topics[i].substring(lastSlash + 1);
                parent    = topics[i].substring(0, lastSlash) + "/";


                /*----------------BEGIN DEBUG------------------*
                System.out.println("I am " + i + "th " + topicName + " Parent "
                                   + parent + " level " + level);

                /*----------------END DEBUG--------------------*/
                findAndInsert(threaded, parent, topicName, level);
            } else {
                /*----------------BEGIN DEBUG------------------*
                System.out.println("I am " + i + "th " + topicName + " Parent "
                                   + parent + " level " + level);

                /*----------------END DEBUG--------------------*/
                TopicNode tNode = new TopicNode();
                tNode.name   = topics[i];
                tNode.parent = "";
                tNode.level  = level;
                threaded.add(tNode);
                //add data to vector
                //sort vector
                //make tnode object
                //add to the threaded
            }

            //topicVec.add();

        }





    }
    public void convertTopicsArrayToThreaded(String[] topics,
                                            String   dir) {
       if (topics == null) {
           return;
       }

       if ((topics != null) && (topics.length == 0)) {
           return;
       }

       threadedTopics         = null;
       threadedTopics         = new Vector();

       boolean   isNew        = false;
       TopicNode tFirstNode = new TopicNode();
       tFirstNode.name        = getName(topics[0]);
       tFirstNode.parent      = getParentName(topics[0]);
       tFirstNode.level       = getLevel(topics[0]);
       tFirstNode.hasSibling  = hasSibling(tFirstNode.level, topics, 0);
       tFirstNode.hasChildren = hasChildren(tFirstNode.level, topics, 0);
       threadedTopics.add(tFirstNode);

       for (int k = 1; k < topics.length; k++) {
           if (tFirstNode.level < getLevel(topics[k])) {
               TopicNode tChildNode = new TopicNode();

               if (tFirstNode.hasSibling) {
                   tChildNode.space += ("<img src=\"" + dir + "/menu_bar.gif\" align=left border=0 vspace=0 hspace=0>");
               } else {
                   tChildNode.space += ("<img src=\"" + dir + "/menu_spacer.gif\" align=left border=0 vspace=0 hspace=0>");
               }


               //tChildNode.space += subSpace;
               threadedTopics.add(tChildNode);
           } else {
               break;
           }
       }

       for (int i = 1; i < (topics.length - 1); i++) {
           TopicNode tNode = null;

           if (i < threadedTopics.size()) {
               tNode = (TopicNode) threadedTopics.get(i);
           } else {
               tNode = new TopicNode();
               isNew = true;
           }

           tNode.name        = getName(topics[i]);
           tNode.parent      = getParentName(topics[i]);
           tNode.level       = getLevel(topics[i]);
           tNode.hasSibling  = hasSibling(tNode.level, topics, i);
           tNode.hasChildren = hasChildren(tNode.level, topics, i);

           if (isNew) {
               threadedTopics.add(tNode);
               isNew = false;
           } else {
               threadedTopics.remove(i);
               threadedTopics.add(i, tNode);
           }

           for (int j = i + 1; j < topics.length; j++) {
               TopicNode tChildNode = null;

               if (tNode.level < getLevel(topics[j])) {
                   if (j < threadedTopics.size()) {
                       tChildNode = (TopicNode) threadedTopics.get(j);
                   } else {
                       tChildNode = new TopicNode();
                       isNew      = true;
                   }

                   if (tNode.hasSibling) {
                       tChildNode.space += ("<img src=\"" + dir + "/menu_bar.gif\" align=left border=0 vspace=0 hspace=0>");
                   } else {
                       tChildNode.space += ("<img src=\"" + dir + "/menu_spacer.gif\" align=left border=0 vspace=0 hspace=0>");
                   }

                   if (isNew) {
                       threadedTopics.add(tChildNode);
                       isNew = false;
                   } else {
                       threadedTopics.remove(j);
                       threadedTopics.add(j, tChildNode);
                   }
               } else {
                   break;
               }
           }
       }

       TopicNode tLastNode = null;

       if ((topics.length - 1) < threadedTopics.size()) {
           tLastNode = (TopicNode) threadedTopics.get(topics.length - 1);
       } else {
           tLastNode = new TopicNode();
           isNew     = true;
       }

       tLastNode.name   = getName(topics[topics.length - 1]);
       tLastNode.parent = getParentName(topics[topics.length - 1]);
       tLastNode.level  = getLevel(topics[topics.length - 1]);

       if (isNew) {
           threadedTopics.add(tLastNode);
           isNew = false;
       } else {
           threadedTopics.remove(topics.length - 1);
           threadedTopics.add(topics.length - 1, tLastNode);
       }
   }


    /**
     * DOCUMENT ME!
     *
     * @param topics DOCUMENT ME!
     */
    public void convertTopicsArrayToThreaded(String[] topics) {
        if (topics == null) {
            return;
        }

        if ((topics != null) && (topics.length == 0)) {
            return;
        }

        threadedTopics = null;
        threadedTopics = new Vector();

        boolean   isNew      = false;
        TopicNode tFirstNode = new TopicNode();

        tFirstNode.name        = getName(topics[0]);
        tFirstNode.parent      = getParentName(topics[0]);
        tFirstNode.level       = getLevel(topics[0]);
        tFirstNode.hasSibling  = hasSibling(tFirstNode.level, topics, 0);
        tFirstNode.hasChildren = hasChildren(tFirstNode.level, topics, 0);
       /* System.out.println(tFirstNode.name + " Has Children ?"
                           + (tFirstNode.hasChildren
                                  ? true
                                  : false));


        //tFirstNode.space += "|---";

        /*
        if (!tFirstNode.hasSibling) {
            tFirstNode.space += "<img src=\"graphics/menu_corner.gif\" align=left border=0 vspace=0 hspace=0>";
        } else {
            tFirstNode.space += "<img src=\"graphics/menu_tee.gif\" align=left border=0 vspace=0 hspace=0>";
        }
        */
        threadedTopics.add(tFirstNode);

        for (int k = 1; k < topics.length; k++) {
            if (tFirstNode.level < getLevel(topics[k])) {
                //System.out.println(tFirstNode.level + " " + getLevel(topics[k]));
                TopicNode tChildNode = new TopicNode();

                //tChildNode.space += "   ";
                if (tFirstNode.hasSibling) {
                    tChildNode.space += "<img src=\"graphics/menu_bar.gif\" align=left border=0 vspace=0 hspace=0>";
                } else {
                    tChildNode.space += "<img src=\"graphics/menu_spacer.gif\" align=left border=0 vspace=0 hspace=0>";
                }

                //tChildNode.space += subSpace;
                threadedTopics.add(tChildNode);
            } else {
                break;
            }
        }

        for (int i = 1; i < (topics.length - 1); i++) {
            TopicNode tNode = null;

            if (i < threadedTopics.size()) {
                tNode = (TopicNode) threadedTopics.get(i);
            } else {
                tNode = new TopicNode();
                isNew = true;
            }

            tNode.name        = getName(topics[i]);
            tNode.parent      = getParentName(topics[i]);
            tNode.level       = getLevel(topics[i]);
            tNode.hasSibling  = hasSibling(tNode.level, topics, i);
            tNode.hasChildren = hasChildren(tNode.level, topics, i);

            if (isNew) {
                threadedTopics.add(tNode);
                isNew = false;
            } else {
                threadedTopics.remove(i);
                threadedTopics.add(i, tNode);
            }

            for (int j = i + 1; j < topics.length; j++) {
                TopicNode tChildNode = null;

                if (tNode.level < getLevel(topics[j])) {
                    if (j < threadedTopics.size()) {
                        tChildNode = (TopicNode) threadedTopics.get(j);
                    } else {
                        tChildNode = new TopicNode();
                        isNew      = true;
                    }

                    if (tNode.hasSibling) {
                        tChildNode.space += "<img src=\"graphics/menu_bar.gif\" align=left border=0 vspace=0 hspace=0>";
                    } else {
                        tChildNode.space += "<img src=\"graphics/menu_spacer.gif\" align=left border=0 vspace=0 hspace=0>";
                    }

                    //tChildNode.space += subSpace;
                    if (isNew) {
                        threadedTopics.add(tChildNode);
                        isNew = false;
                    } else {
                        threadedTopics.remove(j);
                        threadedTopics.add(j, tChildNode);
                    }
                } else {
                    break;
                }
            }
        }

        TopicNode tLastNode = null;

        if ((topics.length - 1) < threadedTopics.size()) {
            tLastNode = (TopicNode) threadedTopics.get(topics.length - 1);
        } else {
            tLastNode = new TopicNode();
            isNew     = true;
        }

        tLastNode.name   = getName(topics[topics.length - 1]);
        tLastNode.parent = getParentName(topics[topics.length - 1]);
        tLastNode.level  = getLevel(topics[topics.length - 1]);

       /* System.out.println(tLastNode.name + " has Children ?"
                           + (tLastNode.hasChildren
                                  ? true
                                  : false));
*/
        //tLastNode.space += "<img src=\"graphics/menu_corner.gif\" align=left border=0 vspace=0 hspace=0>";
        if (isNew) {
            threadedTopics.add(tLastNode);
            isNew = false;
        } else {
            threadedTopics.remove(topics.length - 1);
            threadedTopics.add(topics.length - 1, tLastNode);
        }
        //added for sorting topics correctly 11/24/03


        ////////////////////////////////////

    }

    /**
     * DOCUMENT ME!
     *
     * @param vector DOCUMENT ME!
     * @param parentName DOCUMENT ME!
     *
     * @return DOCUMENT ME!
     */
    public void findAndInsert(Vector vector,
                              String parentName,
                              String topicName,
                              int    level) {
        for (int i = 0; i < vector.size(); i++) {
            if (found) {
                break;
            }

            TopicNode node = (TopicNode) vector.get(i);

            /*----------------BEGIN DEBUG------------------*
            System.out.println("Comparision\t" + parentName);
            System.out.println(node.parent + node.name + "/");
            /*----------------END DEBUG--------------------*/
            if (parentName.equalsIgnoreCase(node.parent + node.name + "/")) {
                TopicNode tNode = new TopicNode();
                tNode.name   = topicName;
                tNode.parent = parentName;
                tNode.level  = level;
                node.itemList.add(tNode);


                /*----------------BEGIN DEBUG------------------*
                   System.out.println("-----------------------------------------Before break");
                /*----------------END DEBUG--------------------*/
                found = true;

                break;
            } else {
                for (int j = 0; j < node.itemList.size(); j++) {
                    findAndInsert(node.itemList, parentName, topicName, level);
                }
            }
        }
    }

    /**
     * DOCUMENT ME!
     *
     * @param args DOCUMENT ME!
     */
    public static void main(String[] args) {
        Database db     = new Database();
        String[] myData = {
            "Grids/Cha101/Cha1001", "Grids/Cha1/Ch1", "Grids/Cha1/Cha",
            "Grids/Ch101/Cha1", "Grids/Ch1a/Ch1", "Grids/Ch10a/Ch1",
            "Grids/Ch20/Ch1", "XML Messaging System/section1/Text11",
            "XML Messaging System/section1", "Grids/Ch2", "HTML/Ch10",
            "XML Messaging System/section1/subsection1", "HTML",
            "Grids/Ch1/Section1/Subsection1",
            "Grids/Ch1/Section1/Subsection1/Text1",
            "Grids/Ch1/Section1/Subsection2", "Grids/Ch1/Section2",
            "Grids/fred", "Grids/Section3", "HTML/Ch1", "HTML/Ch1/Ch1",
            "HTML/Ch1/Ch1/Ch1", "JXTA", "XML", "XML Messaging System", "Grids",
            "Grids/Ch1", "Grids/Ch1/Section1",
            "XML Messaging System/section1/Text1", "HTML/Ch2", "HTML/Ch3",
            "HTML/Ch0", "HTML/Ch11", "Grids/Ch1000", "Grids/Ch1a",
            "Grids/Ch10a", "Grids/Ch20", "Grids/Ch21", "Grids/Ch101",
            "Grids/Cha1", "Grids/Cha10", "Grids/Cha100", "Grids/Cha1001",
            "Grids/Cha101", "Grids/Ch1a101"
        };

        TopicThreaded topicThreaded1 = new TopicThreaded();
        topicThreaded1.convertTopicsArrayToThreaded(myData); //db.getTopicName());

        Vector result = topicThreaded1.getThreadedTopics();

        for (int i = 0; i < result.size(); i++) {
            System.out.println("<tr valign=top><td>"
                               + ((TopicNode) result.get(i)).space
                               + ((TopicNode) result.get(i)).name
                               + "</td></tr>");
        }

        //topicThreaded1.printThreaded(topicThreaded1.threaded);
        //System.out.println(topicThreaded1.data);
    }

    /**
     * DOCUMENT ME!
     *
     * @param level DOCUMENT ME!
     * @param topicsArray DOCUMENT ME!
     * @param startFrom DOCUMENT ME!
     *
     * @return DOCUMENT ME!
     */
    public boolean hasChildren(int      level,
                               String[] topicsArray,
                               int      startFrom) {
    /*    System.out.println("[" + startFrom + "]" + level + "::::[" + startFrom + 1
                           + "]" + getLevel(topicsArray[startFrom + 1]));
*/
        if (((startFrom + 1) < topicsArray.length)
                && (level < getLevel(topicsArray[startFrom + 1]))) {
            return true;
        }

        return false;
    }

    /**
     * DOCUMENT ME!
     *
     * @param level DOCUMENT ME!
     * @param topicsArray DOCUMENT ME!
     * @param startFrom DOCUMENT ME!
     *
     * @return DOCUMENT ME!
     */
    public boolean hasSibling(int      level,
                              String[] topicsArray,
                              int      startFrom) {
        if ((startFrom + 1) < topicsArray.length) {
            for (int i = startFrom + 1; i < topicsArray.length; i++) {
                /*
                 System.out.println("[" + i + "]:" + getLevel(topicsArray[i])
                                    + ":" + level);
                */
                if (getLevel(topicsArray[i]) > level) {
                    continue;
                } else if (getLevel(topicsArray[i]) == level) {
                    return true;
                } else {
                    return false;
                }
            }
        } else {
            return false;
        }

        return false;
    }

    /**
     * DOCUMENT ME!
     *
     * @param vector DOCUMENT ME!
     */
    public void printByThreaded(Vector vector) {
        if (vector.size() > 0) {
            for (int i = 0; i < vector.size(); i++) {
                TopicNode tNode = null;
                String    space = "";

                if (i >= 0) {
                    tNode = (TopicNode) vector.get(i);
                }

                if ((i + 1) == vector.size()) {
                    if (tNode.level == 0) { //if level 0 element is the last item in the list
                        space      = "<img src=\"graphics/menu_corner.gif\" align=left border=0 vspace=0 hspace=0>";
                        childSpace = "";

                        if (tNode.itemList.size() > 0) { //check if it has child
                            childSpace = "&nbsp;&nbsp;&nbsp;";
                            childSpace += "<img src=\"graphics/menu_bar.gif\" align=left border=0 vspace=0 hspace=0>";
                        } else {
                        }
                    } else {
                    }
                } else {
                    //add connection line
                }

                for (int k = 0; k < (tNode.level - 1); k++) {
                    space += "&nbsp;|&nbsp;&nbsp;&nbsp;&nbsp;";
                }

                if (tNode.level > 0) {
                    space += "&nbsp;|....";
                }

                index++;
                data += ("<br>" + space + "<a href=frames.jsp?topic=" + URLEncoder.encode(tNode.parent + tNode.name) + " onClick=\"MM_nbGroup('down','group1','dir" + index + "','images/opendir.gif',0)\">" + "<img src=\"images/dir.gif\" alt=\"\" name=\"dir" + index + "\" width=\"17\" height=\"14\" border=\"0\" onload=\"\">" + tNode.name + "</a>");
                printThreaded(tNode.itemList);
            }
        }
    }

    /**
     * DOCUMENT ME!
     *
     * @param vector DOCUMENT ME!
     *
       public void printByThreaded(Vector vector,
                                   String line) {
           if (vector.size() > 0) {
               for (int i = 0; i < vector.size(); i++) {
                   TopicNode tNode = null;
                   if (i >= 0) {
                       tNode = (TopicNode) vector.get(i);
                   }
                   String space = "";
                   if (tNode.parent == null) {
                       line = "";
                   }
                   if (tNode.itemList.size() > 0) {
                       line += "|";
                   }
                   for (int k = 0; k < (tNode.level - 1); k++) {
                       space += "&nbsp;&nbsp;&nbsp;";
                   }
                   if (tNode.level > 0) {
                       space += ".....";
                   }
                   index++;
                   data += ("<br>" + space + "<a href=frames.jsp?topic=/slide/" + tNode.parent + tNode.name + " onClick=\"MM_nbGroup('down','group1','dir" + index + "','images/opendir.gif',0)\">" + "<img src=\"images/dir.gif\" alt=\"\" name=\"dir" + index + "\" width=\"17\" height=\"14\" border=\"0\" onload=\"\">" + tNode.name + "</a>");
                   printThreaded(tNode.itemList);
               }
           }
       }
     */
    /**
     * DOCUMENT ME!
     *
     * @param vector DOCUMENT ME!
     */
    public void printThreaded(Vector vector) {
        if (vector.size() > 0) {
            for (int i = 0; i < vector.size(); i++) {
                TopicNode tNode = null;

                if (i >= 0) {
                    tNode = (TopicNode) vector.get(i);
                }

                String space = "";

                //if (tNode.itemList.size() > 0) {
                for (int k = 0; k < (tNode.level - 1); k++) {
                    space += "&nbsp;|&nbsp;&nbsp;&nbsp;&nbsp;";
                }

                //}
                if (tNode.level > 0) {
                    space += "&nbsp;|....";
                }


                /*----------------BEGIN DEBUG------------------*
                   System.out.println(tNode.level+" >> "+ space + tNode.name);
                   /*----------------END DEBUG--------------------*/
                index++;
                data += ("<br>" + space + "<a href=frames.jsp?topic=" + URLEncoder.encode(tNode.parent + tNode.name) + " onClick=\"MM_nbGroup('down','group1','dir" + index + "','images/opendir.gif',0)\">" + "<img src=\"images/dir.gif\" alt=\"\" name=\"dir" + index + "\" width=\"17\" height=\"14\" border=\"0\" onload=\"\">" + tNode.name + "</a>");
                printThreaded(tNode.itemList);
            }
        }
    }
}