package commgrids.nuggets.wiley;

import java.io.*;

import java.util.*;


/**
 * DOCUMENT ME!
 *
 * @version $Revision: 1.2 $
 * @author $author$
 */
public class Util {
    public static final String DEFAULT_PROPERTIES = "metadatabrowser.properties";
    static Properties          properties;

    /**
     * DOCUMENT ME!
     *
     * @return DOCUMENT ME!
     *
     * @throws Exception DOCUMENT ME!
     */
    public static Properties getProperties() throws Exception {
        return getProperties(null);
    }

    /**
     * DOCUMENT ME!
     *
     * @param fileName DOCUMENT ME!
     *
     * @return DOCUMENT ME!
     *
     * @throws Exception DOCUMENT ME!
     */
    public static Properties getProperties(String fileName) throws Exception {
        if (properties != null) {
            return properties;
        }

        String     defaultname = DEFAULT_PROPERTIES;
        Properties p = null;

        if ((fileName == null) || fileName.equals("")) {
            fileName = DEFAULT_PROPERTIES;
        }

        try {
            File file = new File(fileName);

            if (file.exists()) {
                p = new Properties();
                p.load(new FileInputStream(file));
                properties = p;

                return p;
            }
        } catch (IOException ioe) {
            // do nothing
        } catch (Exception e) {
            throw e;
        }

        try {
            InputStream is = Util.class.getResourceAsStream("/" + fileName);

            if (is != null) {
                p = new Properties();
                p.load(is);
                properties = p;
            }
        } catch (Exception e) {
            System.out.println("Properties file not found in classpath.");
            throw e;
        }

        return p;
    }
}