/*
////////////////////////////////////////////////////////////////////
//  Module Name : wiley document(DOCUMENT BEAN)                   //
//  Page Name   : newdocParam.java                                //
//  ver 0.9						          //
//  Platform:      ...                                            //
//  Application:   Community Grids Labs, Wiley Document Project   //
//  Author:        Ali Kaplan,  alikapla@cs.indiana.edu           //
//                 Ahmet Topcu  atopcu@cs.indiana.edu             //
//                 Community Grids Labs, Indiana University       //
////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////
    This is a bean class set the variables set by action of the postDocument.
    jsp page,and these objects are used by getDocument.jsp page to set xml and
    rss objects.

    get() ve set() methods for each variable.For example
    public String getDay()  and public void setDay()


/////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////
//                      maintenance page                           //
/////////////////////////////////////////////////////////////////////
//  Build Process                                                  //
//                                                                 //
// Files Required:                                                 //
// 1)postDocument.jsp, getDocument.jsp to get and set variables    //
/////////////////////////////////////////////////////////////////////


    Maintenance History
    ===================
      ver 0.9 : Oct 26 2003
        - first release

    Planned Modifications:
    ======================

*/


package commgrids.nuggets.wiley.bean;

public class newdocParam {
  private String DOILevel      = "";
  private String DOIOrigin     = "";
  private String DOIRegistered = "";
  private String DOIURI        = "";
  private String IID           = "";
  private String ISSN          = "";
  private String ISSNType      = "";
  private String VID           = "";
  private String absractLanguage       = "";
  private String abstractParam         = "";
  private String affiliation           = "";
  private String affiliationCountry    = "";
  private String affiliationSelect     = "";
  private String articleIdentification = "";
  private String articleTitle = "";
  private String articleType = "";
  private String category    = "";
  private String day         = "";
  private String email    = "";
  private String endDay   = "";
  private String endMonth = "";
  private String endYear  = "";
  private String firstName = "";
  private String journalID = "";
  private String journalSortDisplayer = "";
  private String journalSortGroup = "";
  private String journalTitle     = "";
  private String journalTitleLang = "";
  private String keyword1      = "";
  private String keyword2      = "";
  private String keyword3      = "";
  private String lastName      = "";
  private String month         = "";
  private String publisherLoc  = "";
  private String publisherName = "";
  private String subject = "";
  private String year = "";


  public newdocParam() {}

  /**
   * DOCUMENT ME!
   *
   * @param AbsractLanguage_1 - the new value for absractLanguage
   */
  public void setAbsractLanguage(String AbsractLanguage_1) {
    absractLanguage = AbsractLanguage_1;
  }

  /**
   * DOCUMENT ME!
   *
   * @return the String value of absractLanguage.
   */
  public String getAbsractLanguage() {
    return absractLanguage;
  }

  /**
   * DOCUMENT ME!
   *
   * @param AbstractParam_1 - the new value for abstractParam
   */
  public void setAbstractParam(String AbstractParam_1) {
    abstractParam = AbstractParam_1;
  }

  /**
   * DOCUMENT ME!
   *
   * @return the String value of abstractParam.
   */
  public String getAbstractParam() {
    return abstractParam;
  }

  /**
   * DOCUMENT ME!
   *
   * @param Affiliation_1 - the new value for affiliation
   */
  public void setAffiliation(String Affiliation_1) {
    affiliation = Affiliation_1;
  }

  /**
   * DOCUMENT ME!
   *
   * @return the String value of affiliation.
   */
  public String getAffiliation() {
    return affiliation;
  }

  /**
   * DOCUMENT ME!
   *
   * @param AffiliationCountry_1 - the new value for affiliationCountry
   */
  public void setAffiliationCountry(String AffiliationCountry_1) {
    affiliationCountry = AffiliationCountry_1;
  }

  /**
   * DOCUMENT ME!
   *
   * @return the String value of affiliationCountry.
   */
  public String getAffiliationCountry() {
    return affiliationCountry;
  }

  /**
   * DOCUMENT ME!
   *
   * @param AffiliationSelect_1 - the new value for affiliationSelect
   */
  public void setAffiliationSelect(String AffiliationSelect_1) {
    affiliationSelect = AffiliationSelect_1;
  }

  /**
   * DOCUMENT ME!
   *
   * @return the String value of affiliationSelect.
   */
  public String getAffiliationSelect() {
    return affiliationSelect;
  }

  /**
   * DOCUMENT ME!
   *
   * @param ArticleIdentification_1 - the new value for articleIdentification
   */
  public void setArticleIdentification(String ArticleIdentification_1) {
    articleIdentification = ArticleIdentification_1;
  }

  /**
   * DOCUMENT ME!
   *
   * @return the String value of articleIdentification.
   */
  public String getArticleIdentification() {
    return articleIdentification;
  }

  /**
   * DOCUMENT ME!
   *
   * @param ArticleTitle_1 - the new value for articleTitle
   */
  public void setArticleTitle(String ArticleTitle_1) {
    articleTitle = ArticleTitle_1;
  }

  /**
   * DOCUMENT ME!
   *
   * @return the String value of articleTitle.
   */
  public String getArticleTitle() {
    return articleTitle;
  }

  /**
   * DOCUMENT ME!
   *
   * @param ArticleType_1 - the new value for articleType
   */
  public void setArticleType(String ArticleType_1) {
    articleType = ArticleType_1;
  }

  /**
   * DOCUMENT ME!
   *
   * @return the String value of articleType.
   */
  public String getArticleType() {
    return articleType;
  }

  /**
   * DOCUMENT ME!
   *
   * @param Category_1 - the new value for category
   */
  public void setCategory(String Category_1) {
    category = Category_1;
  }

  /**
   * DOCUMENT ME!
   *
   * @return the String value of category.
   */
  public String getCategory() {
    return category;
  }

  /**
   * DOCUMENT ME!
   *
   * @param DOILevel_1 - the new value for DOILevel
   */
  public void setDOILevel(String DOILevel_1) {
    DOILevel = DOILevel_1;
  }

  /**
   * DOCUMENT ME!
   *
   * @return the String value of DOILevel.
   */
  public String getDOILevel() {
    return DOILevel;
  }

  /**
   * DOCUMENT ME!
   *
   * @param DOIOrigin_1 - the new value for DOIOrigin
   */
  public void setDOIOrigin(String DOIOrigin_1) {
    DOIOrigin = DOIOrigin_1;
  }

  /**
   * DOCUMENT ME!
   *
   * @return the String value of DOIOrigin.
   */
  public String getDOIOrigin() {
    return DOIOrigin;
  }

  /**
   * DOCUMENT ME!
   *
   * @param DOIRegistered_1 - the new value for DOIRegistered
   */
  public void setDOIRegistered(String DOIRegistered_1) {
    DOIRegistered = DOIRegistered_1;
  }

  /**
   * DOCUMENT ME!
   *
   * @return the String value of DOIRegistered.
   */
  public String getDOIRegistered() {
    return DOIRegistered;
  }

  /**
   * DOCUMENT ME!
   *
   * @param DOIURI_1 - the new value for DOIURI
   */
  public void setDOIURI(String DOIURI_1) {
    DOIURI = DOIURI_1;
  }

  /**
   * DOCUMENT ME!
   *
   * @return the String value of DOIURI.
   */
  public String getDOIURI() {
    return DOIURI;
  }

  /**
   * DOCUMENT ME!
   *
   * @param Day_1 - the new value for day
   */
  public void setDay(String Day_1) {
    day = Day_1;
  }

  /**
   * DOCUMENT ME!
   *
   * @return the String value of day.
   */
  public String getDay() {
    return day;
  }

  /**
   * DOCUMENT ME!
   *
   * @param Email_1 - the new value for email
   */
  public void setEmail(String Email_1) {
    email = Email_1;
  }

  /**
   * DOCUMENT ME!
   *
   * @return the String value of email.
   */
  public String getEmail() {
    return email;
  }

  /**
   * DOCUMENT ME!
   *
   * @param EndDay_1 - the new value for endDay
   */
  public void setEndDay(String EndDay_1) {
    endDay = EndDay_1;
  }

  /**
   * DOCUMENT ME!
   *
   * @return the String value of endDay.
   */
  public String getEndDay() {
    return endDay;
  }

  /**
   * DOCUMENT ME!
   *
   * @param EndMonth_1 - the new value for endMonth
   */
  public void setEndMonth(String EndMonth_1) {
    endMonth = EndMonth_1;
  }

  /**
   * DOCUMENT ME!
   *
   * @return the String value of endMonth.
   */
  public String getEndMonth() {
    return endMonth;
  }

  /**
   * DOCUMENT ME!
   *
   * @param EndYear_1 - the new value for endYear
   */
  public void setEndYear(String EndYear_1) {
    endYear = EndYear_1;
  }

  /**
   * DOCUMENT ME!
   *
   * @return the String value of endYear.
   */
  public String getEndYear() {
    return endYear;
  }

  /**
   * DOCUMENT ME!
   *
   * @param FirstName_1 - the new value for firstName
   */
  public void setFirstName(String FirstName_1) {
    firstName = FirstName_1;
  }

  /**
   * DOCUMENT ME!
   *
   * @return the String value of firstName.
   */
  public String getFirstName() {
    return firstName;
  }

  /**
   * DOCUMENT ME!
   *
   * @param IID_1 - the new value for IID
   */
  public void setIID(String IID_1) {
    IID = IID_1;
  }

  /**
   * DOCUMENT ME!
   *
   * @return the String value of IID.
   */
  public String getIID() {
    return IID;
  }

  /**
   * DOCUMENT ME!
   *
   * @param ISSN_1 - the new value for ISSN
   */
  public void setISSN(String ISSN_1) {
    ISSN = ISSN_1;
  }

  /**
   * DOCUMENT ME!
   *
   * @return the String value of ISSN.
   */
  public String getISSN() {
    return ISSN;
  }

  /**
   * DOCUMENT ME!
   *
   * @param ISSNType_1 - the new value for ISSNType
   */
  public void setISSNType(String ISSNType_1) {
    ISSNType = ISSNType_1;
  }

  /**
   * DOCUMENT ME!
   *
   * @return the String value of ISSNType.
   */
  public String getISSNType() {
    return ISSNType;
  }

  /**
   * DOCUMENT ME!
   *
   * @param JournalID_1 - the new value for journalID
   */
  public void setJournalID(String JournalID_1) {
    journalID = JournalID_1;
  }

  /**
   * DOCUMENT ME!
   *
   * @return the String value of journalID.
   */
  public String getJournalID() {
    return journalID;
  }

  /**
   * DOCUMENT ME!
   *
   * @param JournalSortDisplayer_1 - the new value for journalSortDisplayer
   */
  public void setJournalSortDisplayer(String JournalSortDisplayer_1) {
    journalSortDisplayer = JournalSortDisplayer_1;
  }

  /**
   * DOCUMENT ME!
   *
   * @return the String value of journalSortDisplayer.
   */
  public String getJournalSortDisplayer() {
    return journalSortDisplayer;
  }

  /**
   * DOCUMENT ME!
   *
   * @param JournalSortGroup_1 - the new value for journalSortGroup
   */
  public void setJournalSortGroup(String JournalSortGroup_1) {
    journalSortGroup = JournalSortGroup_1;
  }

  /**
   * DOCUMENT ME!
   *
   * @return the String value of journalSortGroup.
   */
  public String getJournalSortGroup() {
    return journalSortGroup;
  }

  /**
   * DOCUMENT ME!
   *
   * @param JournalTitle_1 - the new value for journalTitle
   */
  public void setJournalTitle(String JournalTitle_1) {
    journalTitle = JournalTitle_1;
  }

  /**
   * DOCUMENT ME!
   *
   * @return the String value of journalTitle.
   */
  public String getJournalTitle() {
    return journalTitle;
  }

  /**
   * DOCUMENT ME!
   *
   * @param JournalTitleLang_1 - the new value for journalTitleLang
   */
  public void setJournalTitleLang(String JournalTitleLang_1) {
    journalTitleLang = JournalTitleLang_1;
  }

  /**
   * DOCUMENT ME!
   *
   * @return the String value of journalTitleLang.
   */
  public String getJournalTitleLang() {
    return journalTitleLang;
  }

  /**
   * DOCUMENT ME!
   *
   * @param Keyword1_1 - the new value for keyword1
   */
  public void setKeyword1(String Keyword1_1) {
    keyword1 = Keyword1_1;
  }

  /**
   * DOCUMENT ME!
   *
   * @return the String value of keyword1.
   */
  public String getKeyword1() {
    return keyword1;
  }

  /**
   * DOCUMENT ME!
   *
   * @param Keyword2_1 - the new value for keyword2
   */
  public void setKeyword2(String Keyword2_1) {
    keyword2 = Keyword2_1;
  }

  /**
   * DOCUMENT ME!
   *
   * @return the String value of keyword2.
   */
  public String getKeyword2() {
    return keyword2;
  }

  /**
   * DOCUMENT ME!
   *
   * @param Keyword3_1 - the new value for keyword3
   */
  public void setKeyword3(String Keyword3_1) {
    keyword3 = Keyword3_1;
  }

  /**
   * DOCUMENT ME!
   *
   * @return the String value of keyword3.
   */
  public String getKeyword3() {
    return keyword3;
  }

  /**
   * DOCUMENT ME!
   *
   * @param LastName_1 - the new value for lastName
   */
  public void setLastName(String LastName_1) {
    lastName = LastName_1;
  }

  /**
   * DOCUMENT ME!
   *
   * @return the String value of lastName.
   */
  public String getLastName() {
    return lastName;
  }

  /**
   * DOCUMENT ME!
   *
   * @param Month_1 - the new value for month
   */
  public void setMonth(String Month_1) {
    month = Month_1;
  }

  /**
   * DOCUMENT ME!
   *
   * @return the String value of month.
   */
  public String getMonth() {
    return month;
  }

  /**
   * DOCUMENT ME!
   *
   * @param PublisherLoc_1 - the new value for publisherLoc
   */
  public void setPublisherLoc(String PublisherLoc_1) {
    publisherLoc = PublisherLoc_1;
  }

  /**
   * DOCUMENT ME!
   *
   * @return the String value of publisherLoc.
   */
  public String getPublisherLoc() {
    return publisherLoc;
  }

  /**
   * DOCUMENT ME!
   *
   * @param PublisherName_1 - the new value for publisherName
   */
  public void setPublisherName(String PublisherName_1) {
    publisherName = PublisherName_1;
  }

  /**
   * DOCUMENT ME!
   *
   * @return the String value of publisherName.
   */
  public String getPublisherName() {
    return publisherName;
  }

  /**
   * DOCUMENT ME!
   *
   * @param Subject_1 - the new value for subject
   */
  public void setSubject(String Subject_1) {
    subject = Subject_1;
  }

  /**
   * DOCUMENT ME!
   *
   * @return the String value of subject.
   */
  public String getSubject() {
    return subject;
  }

  /**
   * DOCUMENT ME!
   *
   * @param VID_1 - the new value for VID
   */
  public void setVID(String VID_1) {
    VID = VID_1;
  }

  /**
   * DOCUMENT ME!
   *
   * @return the String value of VID.
   */
  public String getVID() {
    return VID;
  }

  /**
   * DOCUMENT ME!
   *
   * @param Year_1 - the new value for year
   */
  public void setYear(String Year_1) {
    year = Year_1;
  }

  /**
   * DOCUMENT ME!
   *
   * @return the String value of year.
   */
  public String getYear() {
    return year;
  }

  public static void main(String[] args) {
    newdocParam newdocParam1 = new newdocParam();
  }
}
