package willeyconverter.util;

import commgrids.nuggets.wiley.*;
import commgrids.nuggets.wiley.MessageThread;
import commgrids.nuggets.wiley.schema.*;

import willeyconverter.util.*;

import java.io.*;
import java.io.FileInputStream;
import java.io.FileOutputStream;

import java.net.*;

import java.util.*;


public class WileyHTMLGenerator {
  public static void main(String[] args) {
    Database                  db                 = new Database();
    FullWileyHTMLDocument     fWileyHTMLDocument = new FullWileyHTMLDocument();
    AbstractWileyHTMLDocument aWileyHTMLDocument = new AbstractWileyHTMLDocument();
    LightWileyHTMLDocument    lWileyHTMLDocument = new LightWileyHTMLDocument();

    db.getMessages(); //generate txt messages in the directory defined in the properties file.
    fWileyHTMLDocument.generateFullDocument(); //generate full html documents specified for the topic defined in the properties file
    aWileyHTMLDocument.generateAbstractDocument(); //generate abstract html documents specified for the topic defined in the properties file
    lWileyHTMLDocument.generateLightDocument(); //generate light html documents specified for the topic defined in the properties file
  }
   //end main
}
 // end class
