package commgrids.nuggets.wiley;

/**
 * DOCUMENT ME!
 *
 * @version $Revision: 1.1.1.1 $
 * @author $author$
 */
public class Topic {
    private String adminName        = "";
    private String topicDescription = "";
    private String topicID          = "";
    private String topicName        = "";

    /**
     * Creates a new Topic object.
     *
     * @param topicID DOCUMENT ME!
     * @param topicName DOCUMENT ME!
     * @param topicDescription DOCUMENT ME!
     */
    public Topic(String topicID,
                 String topicName,
                 String topicDescription) {
        this.topicName        = topicName;
        this.topicID          = topicID;
        this.topicDescription = topicDescription;
    }

    /**
     * Creates a new Topic object.
     *
     * @param topicID DOCUMENT ME!
     * @param topicName DOCUMENT ME!
     * @param topicDescription DOCUMENT ME!
     * @param adminName DOCUMENT ME!
     */
    public Topic(String topicID,
                 String topicName,
                 String topicDescription,
                 String adminName) {
        this.topicName        = topicName;
        this.topicID          = topicID;
        this.topicDescription = topicDescription;
        this.adminName        = adminName;
    }

    /**
     * Creates a new Topic object.
     */
    public Topic() {
    }

    /**
     *
     * @param aAdminName - the new value for adminName
     */
    public void setAdminName(String aAdminName) {
        adminName = aAdminName;
    }

    /**
     *
     * @return the String value of adminName.
     */
    public String getAdminName() {
        return adminName;
    }

    /**
     *
     * @param aTopicDescription - the new value for topicDescription
     */
    public void setTopicDescription(String aTopicDescription) {
        topicDescription = aTopicDescription;
    }

    /**
     *
     * @return the String value of topicDescription.
     */
    public String getTopicDescription() {
        return topicDescription;
    }

    /**
     *
     * @param aTopicID - the new value for topicID
     */
    public void setTopicID(String aTopicID) {
        topicID = aTopicID;
    }

    /**
     *
     * @return the String value of topicID.
     */
    public String getTopicID() {
        return topicID;
    }

    /**
     *
     * @param aTopicName - the new value for topicName
     */
    public void setTopicName(String aTopicName) {
        topicName = aTopicName;
    }

    /**
     *
     * @return the String value of topicName.
     */
    public String getTopicName() {
        return topicName;
    }

    /**
     * DOCUMENT ME!
     *
     * @param temp DOCUMENT ME!
     *
     * @return DOCUMENT ME!
     */
    public int compareByTopicID(Topic temp) {
        int result = this.topicID.compareTo(temp.topicID);

        if (result < 0) {
            return -1;
        } else if (result > 0) {
            return 1;
        } else {
            return 0;
        }
    }

    /**
     * DOCUMENT ME!
     *
     * @param temp DOCUMENT ME!
     *
     * @return DOCUMENT ME!
     */
    public int compareByTopicName(Topic temp) {
         if(temp.topicName!=null && topicName!=null){
        int result = this.topicName.compareTo(temp.topicName);

        if (result < 0) {
            return -1;
        } else if (result > 0) {
            return 1;
        } else {
            return 0;
        }
    }
        return -1;
    }

    /**
     * DOCUMENT ME!
     *
     * @param temp DOCUMENT ME!
     *
     * @return DOCUMENT ME!
     */
    public int compareByTopicDescription(Topic temp) {
        if(temp.topicDescription!=null && topicDescription!=null){
        int result = this.topicDescription.compareTo(temp.topicDescription);

        if (result < 0) {
            return -1;
        } else if (result > 0) {
            return 1;
        } else {
            return 0;
        }
        }
        return -1;
    }
    public int compareByTopicAdminName(Topic temp) {
         if(temp.adminName!=null && adminName!=null){
        int result = this.adminName.compareTo(temp.adminName);

        if (result < 0) {
            return -1;
        } else if (result > 0) {
            return 1;
        } else {
            return 0;
        }
         }
        return -1;
    }

    /**
     * DOCUMENT ME!
     *
     * @param args DOCUMENT ME!
     */
    public static void main(String[] args) {
        Topic topic1 = new Topic();
    }
}