package commgrids.nuggets.wiley;

import java.io.StringReader;

import java.util.Iterator;
import java.util.List;
import java.util.Vector;

import org.apache.xerces.parsers.DOMParser;

import org.jdom.Attribute;
import org.jdom.Document;
import org.jdom.Element;

import org.jdom.input.SAXBuilder;


/**
 * DOCUMENT ME!
 *
 * @version $Revision: 1.1.1.1 $
 * @author $author$
 */
public class RecursiveParser {

    Vector           nodeVector = new Vector();
    private Document doc = null;

    /** DOCUMENT ME! */
    private String metaData = "";

    /**
     * Creates a new RecursiveParser object.
     */
    public RecursiveParser() {
    }

    /**
     * DOCUMENT ME!
     *
     * @param aMetaData DOCUMENT ME!
     */
    public void setMetaData(String aMetaData) {
        metaData = aMetaData;
    }

    /**
     * DOCUMENT ME!
     *
     * @return DOCUMENT ME!
     */
    public String getMetaData() {

        return metaData;
    }

    /**
     *
     * @param aNodeVector - the new value for nodeVector
     */
    public void setNodeVector(Vector aNodeVector) {
        nodeVector = aNodeVector;
    }

    /**
     *
     * @return the Vector value of nodeVector.
     */
    public Vector getNodeVector() {

        return nodeVector;
    }

    /**
     * DOCUMENT ME!
     *
     * @param args DOCUMENT ME!
     */
    public void getURIName(String uri) {

        RecursiveParser recursiveParser = new RecursiveParser();

        /*String          message = "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n";
           message += "<course>\n";
           message += "<name id=\"csci_2962\">Programming XML in Java</name>\n";
           message += "<teacher id=\"jp\">\n";
           message += "<name>John Punin</name>\n";
           message += "</teacher>\n";
           message += "<student id=\"js\">\n";
           message += "<name>John Smith</name>\n";
           message += "<hw1>30</hw1>\n";
           message += "<hw2>70</hw2>\n";
           message += "<project>80</project>\n";
           message += "<final>85</final>\n";
           message += "</student>\n";
           message += "<student id=\"gl\">\n";
           message += "<name>George Lucas</name>\n";
           message += "<hw1>80</hw1>\n";
           message += "<hw2>90</hw2>\n";
           message += "<project>100</project>\n";
           message += "<final>40</final>\n";
           message += "</student>\n";
           message += "<student id=\"lr\">\n";
           message += "<name>Elizabeth Roberts</name>\n";
           message += "<hw1>60</hw1>\n";
           message += "<hw2>95</hw2>\n";
           message += "<project>50</project>\n";
           message += "<final>90</final>\n";
           message += "</student>\n";
           message += "</course>";
           //System.out.println (message);
         */
        recursiveParser.parseURIXML(uri);

        //recursiveParser1.parseXML (message);
        //System.out.println(recursiveParser.getMetaData());
    }

    /**
     * DOCUMENT ME!
     *
     * @param xmlMsg DOCUMENT ME!
     * @param msgLink DOCUMENT ME!
     *
     * @return DOCUMENT ME!
     */
    public String combineAttachmentLinks(String xmlMsg,
                                         String msgLink) {

        try {

            //String id = java.net.URLEncoder.encode(
            //String id = Util.getProperties().getProperty("attachment.jsp.location")+msgLink.substring(msgLink.indexOf("gxos://")+7);
            //String slideLocation = Util.getProperties().getProperty("slide.location");
            String id ="attachmentservlet";
            xmlMsg = this.searchReplace(xmlMsg, "<Location>", "<Location>" + id, 0);
        } catch (Exception ex) {
            ex.printStackTrace();
        }

        return xmlMsg;
    }

    /**
     * DOCUMENT ME!
     *
     * @param xmlDoc DOCUMENT ME!
     */
    public void parseStringXML(String stringXML) {

        try {

           //stringXML = combineAttachmentLinks(stringXML,"");
           StringReader sr      = new StringReader(stringXML);
            SAXBuilder   builder = new SAXBuilder();
            doc = builder.build(sr);

            Iterator i = doc.getRootElement()
                            .getChildren()
                            .iterator();
            this.parseXML(i);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    /**
     * DOCUMENT ME!
     *
     * @param xmlDoc DOCUMENT ME!
     */
    public void parseURIXML(String uri) {

        try {

            SAXBuilder builder = new SAXBuilder();
            this.doc = builder.build(uri);

            Iterator i = this.doc.getRootElement()
                                 .getChildren()
                                 .iterator();
            this.parseXML(i);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    /**
     * DOCUMENT ME!
     *
     * @param elementName DOCUMENT ME!
     * @param AttributeName DOCUMENT ME!
     *
     * @return DOCUMENT ME!
     */

    /*  public String getAttributeValue (String elementName,
       String AttributeName) {
       String attributeValue = null;
       try {
           Iterator i = this.doc.getRootElement ()
                                .getChildren ()
                                .iterator ();
           attributeValue = this.getAttributeValueTail (i, elementName,
                                                        AttributeName);
       } catch (Exception e) {
       }
       return attributeValue;
       }
     */

    /**
     * DOCUMENT ME!
     *
     * @param i DOCUMENT ME!
     * @param elementName DOCUMENT ME!
     * @param AttributeName DOCUMENT ME!
     *
     * @return DOCUMENT ME!
     */

    /* public String getAttributeValueTail (Iterator i,
       String   elementName,
       String   AttributeName) {
       String attributeValue = null;
       try {
           while (i.hasNext ()) {
               Element e = (Element) i.next ();
               if (e.getName ()
                    .equalsIgnoreCase (elementName)) {
                   attributeValue = e.getAttributeValue (AttributeName);
                   break;
               } else {
                   Iterator ii = e.getChildren ()
                                  .iterator ();
                   attributeValue = this.getAttributeValueTail (ii,
                                                                elementName,
                                                                AttributeName);
               }
           }
       } catch (Exception e) {
       }
       return attributeValue;
       }
     */

    /**
     * DOCUMENT ME!
     *
     * @param i DOCUMENT ME!
     */
    public void parseXML(Iterator i) {

        try {

            while (i.hasNext()) {

                Element e = (Element) i.next();

                /*
                   System.out.println("Element name: " + e.getName() +
                                      "\t\tElement Value: " + e.getTextTrim());
                 */

                //node object
                XMLNodeObject nodeObject = new XMLNodeObject();
                nodeObject.setNodeName(e.getName());
                nodeObject.setNodeValue(e.getTextTrim());

                List list = e.getAttributes();

                if (list.size() == 0) {

                    //add the node object to the vector
                    nodeVector.addElement(nodeObject);
                } else {

                    Vector attrVector = new Vector();

                    for (int k = 0; k < list.size(); k++) {
                        this.metaData += "\n<tr>";

                        Attribute att = (Attribute) list.get(k);

                        /*
                           System.out.println("Attribute name: " +
                                              att.getName() +
                                              "\tAttribute Value: " +
                                              att.getValue());
                         */
                        XMLAttributeObject attrObject = new XMLAttributeObject();
                        attrObject.setAttributeName(att.getName());
                        attrObject.setAttributeValue(att.getValue());
                        attrVector.addElement(attrObject);
                        nodeObject.setAttrVector(attrVector);
                    } //end for


                    //add the node element having the node attributes
                    nodeVector.addElement(nodeObject);
                } //end else

                if (e == null) {

                    break;
                } else {

                    Iterator ii = e.getChildren()
                                   .iterator();
                    e.removeChild(e.getName());
                    parseXML(ii);
                }
            }
        } catch (Exception e) {
        }
    }

    /**
     * DOCUMENT ME!
     *
     * @param data DOCUMENT ME!
     * @param find DOCUMENT ME!
     * @param replace DOCUMENT ME!
     * @param index DOCUMENT ME!
     *
     * @return DOCUMENT ME!
     */
    private static String searchReplace(String data,
                                        String find,
                                        String replace,
                                        int    index) {

        StringBuffer sb         = new StringBuffer();
        int          a          = index;
        int          b;
        int          findLength = find.length();
        sb.append(data.substring(0, a));

        while ((b = data.indexOf(find, a)) != -1) {
            sb.append(data.substring(a, b));
            sb.append(replace);
            a = b + findLength;
        }

        if (a < data.length()) {
            sb.append(data.substring(a));
        }

        return sb.toString();
    }
}