package commgrids.nuggets.wiley;

/**
 * DOCUMENT ME!
 *
 * @version $Revision: 1.1.1.1 $
 * @author $author$
 */
public class Registration extends Login { //implements LoginInterface{

    private String email          = "";
    private String emailError     = "";
    private String firstName      = "";
    private String firstNameError = "";
    private String lastName       = "";
    private String lastNameError  = "";
    private String  repassword = "";
    private boolean checkData = true;
    private boolean debug     = false;

    /**
    *
    * @return true if checkData is set to true.
    */
    public boolean isCheckData() {
        return checkData;
    }

    /**
    *
    * @param aEmail - the new value for email
    */
    public void setEmail(String aEmail) {
        email = aEmail;
    }

    /**
    *
    * @return the String value of email.
    */
    public String getEmail() {
        return email;
    }

    /**
    *
    * @param aEmailError - the new value for emailError
    */
    public void setEmailError(String aEmailError) {
        emailError = aEmailError;
    }

    /**
    *
    * @return the String value of emailError.
    */
    public String getEmailError() {
        return emailError;
    }

    /**
    *
    * @param aFirstName - the new value for firstName
    */
    public void setFirstName(String aFirstName) {
        firstName = aFirstName;
    }

    /**
    *
    * @return the String value of firstName.
    */
    public String getFirstName() {
        return firstName;
    }

    /**
    *
    * @param aFirstNameError - the new value for firstNameError
    */
    public void setFirstNameError(String aFirstNameError) {
        firstNameError = aFirstNameError;
    }

    /**
    *
    * @return the String value of firstNameError.
    */
    public String getFirstNameError() {
        return firstNameError;
    }

    /**
    *
    * @param aLastName - the new value for lastName
    */
    public void setLastName(String aLastName) {
        lastName = aLastName;
    }

    /**
    *
    * @return the String value of lastName.
    */
    public String getLastName() {
        return lastName;
    }

    /**
    *
    * @param aLastNameError - the new value for lastNameError
    */
    public void setLastNameError(String aLastNameError) {
        lastNameError = aLastNameError;
    }

    /**
    *
    * @return the String value of lastNameError.
    */
    public String getLastNameError() {
        return lastNameError;
    }

    /**
    *
    * @param aRepassword - the new value for repassword
    */
    public void setRepassword(String aRepassword) {
        repassword = aRepassword;
    }

    /**
    *
    * @return the String value of repassword.
    */
    public String getRepassword() {
        return repassword;
    }

    /**
     * DOCUMENT ME!
     */
    public void clearErrors() {
        super.clearErrors();
        emailError     = "";
        firstNameError = "";
        lastNameError  = "";
    }

    /**
     * DOCUMENT ME!
     */
    public void debugOFF() {
        debug = false;
    }

    /**
     * DOCUMENT ME!
     */
    public void debugON() {
        debug = true;
    }

    /**
     * DOCUMENT ME!
     *
     * @param args DOCUMENT ME!
     */
    public static void main(String[] args) {
        Registration registration1 = new Registration();
    }

    /**
     * DOCUMENT ME!
     *
     * @return DOCUMENT ME!
     */
    public boolean addUser() {
        super.database = new Database();

        return super.database.insertUser(this);
    }

    /**
     * DOCUMENT ME!
     *
     * @return DOCUMENT ME!
     */
    public boolean validate() {
        clearErrors();
        checkData      = true;
        super.database = new Database();

        if (super.getUserName()
                 .length() == 0) {
            super.setUserNameError(
                    "Username can not be blank. Please enter your username...");

            if (debug) {
                System.out.println(
                        "Username can not be blank. Please enter your username...");
            }

            checkData = false;
        }

        /*else if (!super.database.validateUsername(super)) {
            checkData = false;
            super.setUserNameError(
                    "This username has already been in use. Please select a new one.");

            if (debug) {
                System.out.println(
                        "This username has already been in use. Please select a new one.");
            }
        }
*/
        if (debug) {
            System.out.println("Password is " + super.getPassword() + "   "
                               + "repassword is " + repassword);
        }

        if ((super.getPassword().length() == 0) || (repassword.length() == 0)) {
            if (debug) {
                System.out.println("inside empty");
            }

            super.setPasswordError(
                    "Password can not be blank. Please enter your password");
            checkData = false;

            if (debug) {
                System.out.println(
                        "Password can not be blank. Please enter your password");
            }
        } else if (super.getPassword()
                        .compareTo(repassword) != 0) {
            if (debug) {
                System.out.println("inside does not match");
            }

            checkData = false;
            super.setPasswordError("Passwords does not match!");
            super.setPassword("");
            repassword = "";

            if (debug) {
                System.out.println("Passwords does not match!");
            }
        }

        if (debug) {
            System.out.println("Password is " + super.getPassword() + "   "
                               + "repassword is " + repassword);
        }

        if (debug) {
            System.out.println("before First name can not be blank "
                               + firstName);
        }

        if (firstName.length() == 0) {
            firstNameError = "First name can not be blank. Please enter your first name";
            checkData      = false;

            if (debug) {
                System.out.println(
                        "First name can not be blank. Please enter your first name");
            }
        }

        if (debug) {
            System.out.println("after First name can not be blank " + firstName);
        }

        if (lastName.length() == 0) {
            lastNameError = "Last Name can not be blank. Please enter your last name";
            checkData     = false;

            if (debug) {
                System.out.println(
                        "Last Name can not be blank. Please enter your last name");
            }
        }

        if (email.length() == 0) {
            emailError = "Email can not be blank. Please enter your email";
            checkData  = false;

            if (debug) {
                System.out.println(
                        "Email can not be blank. Please enter your email");
            }
        }

        super.database = null;

        return checkData;
    }

    /**
    *
    * @param aCheckData - the new value for checkData
    */
    private void setCheckData(boolean aCheckData) {
        checkData = aCheckData;
    }
}
