package newsrequest;

/**
 * <p>Title: </p>
 * <p>Description: newsgroup request</p>
 * <p>Copyright: Copyright (c) 2001</p>
 * <p>Company: Pervasive Tech Labs </p>
 * @author Ahmet E Topcu
 * @version 0.90
 */
public class User {
    private String  adminname      = null;
    private String  email          = null;
    private String  topicname      = null;
    private String  uname          = null;
    private boolean added          = false;
    private boolean deleted        = false;
    private boolean deletedRequest = false;
    private boolean selected       = false;
    private int     admin          = 0;
    private int     attachNotify   = 0;
    private int     ccNotify       = 0;
    private int     emailNotify    = 0;
    private int     read           = 0;
    private int     write          = 0;

    /**
     * Creates a new User object.
     *
     * @param uname DOCUMENT ME!
     * @param gname DOCUMENT ME!
     * @param aname DOCUMENT ME!
     * @param email DOCUMENT ME!
     */
    public User(String uname,
                String gname,
                String aname,
                String email) {
        this.uname     = uname;
        this.topicname = gname;
        this.adminname = aname;
        this.email     = email;
    }

    /**
     * Creates a new User object.
     *
     * @param uname DOCUMENT ME!
     * @param gname DOCUMENT ME!
     * @param aname DOCUMENT ME!
     */
    public User(String uname,
                String gname,
                String aname) {
        this.uname     = uname;
        this.topicname = gname;
        this.adminname = aname;
    }

    /**
     * Creates a new User object.
     */
    public User() {
    }

    /**
     * DOCUMENT ME!
     *
     * @param add DOCUMENT ME!
     */
    public void setAddUser(boolean add) {
        this.added = add;
    }

    /**
     * DOCUMENT ME!
     *
     * @return DOCUMENT ME!
     */
    public boolean getAddUser() {
        return this.added;
    }

    /**
     * DOCUMENT ME!
     *
     * @param admin DOCUMENT ME!
     */
    public void setAdmin(int admin) {
        this.admin = admin;
    }

    /**
     * DOCUMENT ME!
     *
     * @return DOCUMENT ME!
     */
    public int getAdmin() {
        return this.admin;
    }

    /**
     * DOCUMENT ME!
     *
     * @param adminname DOCUMENT ME!
     */
    public void setAdminname(String adminname) {
        this.adminname = adminname;
    }

    /**
     * DOCUMENT ME!
     *
     * @return DOCUMENT ME!
     */
    public String getAdminname() {
        return this.adminname;
    }

    /**
     * DOCUMENT ME!
     *
     * @param attach DOCUMENT ME!
     */
    public void setAttachNotify(int attach) {
        this.attachNotify = attach;
    }

    /**
     * DOCUMENT ME!
     *
     * @return DOCUMENT ME!
     */
    public int getAttachNotify() {
        return this.attachNotify;
    }

    /**
     * DOCUMENT ME!
     *
     * @param cc DOCUMENT ME!
     */
    public void setCCNotify(int cc) {
        this.ccNotify = cc;
    }

    /**
     * DOCUMENT ME!
     *
     * @return DOCUMENT ME!
     */
    public int getCCNotify() {
        return this.ccNotify;
    }

    /**
     * DOCUMENT ME!
     *
     * @param delete DOCUMENT ME!
     */
    public void setDeleted(boolean delete) {
        this.deleted = delete;
    }

    /**
     * DOCUMENT ME!
     *
     * @return DOCUMENT ME!
     */
    public boolean getDeleted() {
        return this.deleted;
    }

    /**
     *
     * @param aDeletedRequest - the new value for deletedRequest
     */
    public void setDeletedRequest(boolean aDeletedRequest) {
        deletedRequest = aDeletedRequest;
    }

    /**
     *
     * @return true if deletedRequest is set to true.
     */
    public boolean isDeletedRequest() {
        return deletedRequest;
    }

    /**
     * DOCUMENT ME!
     *
     * @param email DOCUMENT ME!
     */
    public void setEmail(String email) {
        this.email = email;
    }

    /**
     * DOCUMENT ME!
     *
     * @return DOCUMENT ME!
     */
    public String getEmail() {
        return this.email;
    }

    /**
     * DOCUMENT ME!
     *
     * @param enotify DOCUMENT ME!
     */
    public void setEmailNotify(int enotify) {
        this.emailNotify = enotify;
    }

    /**
     * DOCUMENT ME!
     *
     * @return DOCUMENT ME!
     */
    public int getEmailNotify() {
        return this.emailNotify;
    }

    /**
     *
     * @param read
     */
    public void setRead(int read) {
        this.read = read;
    }

    /**
     * DOCUMENT ME!
     *
     * @return DOCUMENT ME!
     */
    public int getRead() {
        return this.read;
    }

    /**
     * DOCUMENT ME!
     *
     * @param select DOCUMENT ME!
     */
    public void setSelected(boolean select) {
        this.selected = select;
    }

    /**
     * DOCUMENT ME!
     *
     * @return DOCUMENT ME!
     */
    public boolean getSelected() {
        return this.selected;
    }

    /**
     * DOCUMENT ME!
     *
     * @param groupname DOCUMENT ME!
     */
    public void setTopicName(String topicname) {
        this.topicname = topicname;
    }

    /**
     * DOCUMENT ME!
     *
     * @return DOCUMENT ME!
     */
    public String getTopicName() {
        return this.topicname;
    }

    /**
     * DOCUMENT ME!
     *
     * @param username DOCUMENT ME!
     */
    public void setUsername(String username) {
        this.uname = username;
    }

    /**
     * DOCUMENT ME!
     *
     * @return DOCUMENT ME!
     */
    public String getUsername() {
        return this.uname;
    }

    /**
     * DOCUMENT ME!
     *
     * @param write DOCUMENT ME!
     */
    public void setWrite(int write) {
        this.write = write;
    }

    /**
     * DOCUMENT ME!
     *
     * @return DOCUMENT ME!
     */
    public int getWrite() {
        return this.write;
    }

    /**
     * DOCUMENT ME!
     *
     * @return DOCUMENT ME!
     */
    public String toString() {
        String out = "User name: " + this.uname + "\n";
        out += ("Group name: " + this.topicname + "\n");
        out += ("Admin name: " + this.adminname + "\n");
        out += ("Email: " + this.email + "\n");
        out += ("Read: " + String.valueOf(this.read) + "\n");
        out += ("Write: " + String.valueOf(this.write) + "\n");
        out += ("Admin: " + String.valueOf(this.admin) + "\n");
        out += ("Email Notify: " + String.valueOf(this.emailNotify) + "\n");
        out += ("Attachment Notify: " + String.valueOf(this.attachNotify) + "\n");
        out += ("CC Notify: " + String.valueOf(this.ccNotify) + "\n");
        out += ("Selected: " + String.valueOf(this.selected) + "\n");
        out += ("Deleted: " + String.valueOf(this.deleted) + "\n");

        return out;
    }
}